/* chess-state.c generated by valac 0.42.3, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;
typedef struct _ChessStatePrivate ChessStatePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_COLOR (color_get_type ())

#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef struct _ChessPiecePrivate ChessPiecePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ChessMovePrivate ChessMovePrivate;

#define TYPE_CHESS_RULE (chess_rule_get_type ())

#define TYPE_CHESS_RESULT (chess_result_get_type ())

typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;

struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;

typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};

typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;

typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;


static gint ChessState_private_offset;
static gpointer chess_state_parent_class = NULL;

GType check_state_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
GType chess_player_get_type (void) G_GNUC_CONST;
GType chess_piece_get_type (void) G_GNUC_CONST;
GType chess_move_get_type (void) G_GNUC_CONST;
static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType color_get_type (void) G_GNUC_CONST;
ChessPlayer* chess_player_new (Color color);
ChessPlayer* chess_player_construct (GType object_type,
                                     Color color);
GType piece_type_get_type (void) G_GNUC_CONST;
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
ChessPiece* chess_piece_new (ChessPlayer* player,
                             PieceType type);
ChessPiece* chess_piece_construct (GType object_type,
                                   ChessPlayer* player,
                                   PieceType type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
ChessState* chess_state_copy (ChessState* self);
ChessMove* chess_move_copy (ChessMove* self);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
gchar* chess_state_get_fen (ChessState* self);
gunichar chess_piece_get_symbol (ChessPiece* self);
gint chess_state_get_file (ChessState* self,
                           gint index);
gint chess_state_get_rank (ChessState* self,
                           gint index);
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
gboolean chess_state_move_with_coords (ChessState* self,
                                       ChessPlayer* player,
                                       gint r0,
                                       gint f0,
                                       gint r1,
                                       gint f1,
                                       PieceType promotion_type,
                                       gboolean apply,
                                       gboolean test_check);
Color chess_piece_get_color (ChessPiece* self);
gboolean chess_state_is_in_check (ChessState* self,
                                  ChessPlayer* player);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_result_get_type (void) G_GNUC_CONST;
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
static gboolean chess_state_can_move (ChessState* self,
                               ChessPlayer* player);
gboolean chess_state_have_sufficient_material (ChessState* self);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
ChessPlayer* chess_state_get_opponent (ChessState* self);
static void chess_state_finalize (GObject * obj);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const gint64 BIT_BOARD_set_location_masks[64];
extern const gint64 BIT_BOARD_move_masks[768];
extern const gint64 BIT_BOARD_over_masks[4096];
extern const gint64 BIT_BOARD_clear_location_masks[64];

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__volatile = 0;
	if (g_once_init_enter (&check_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
		GType check_state_type_id;
		check_state_type_id = g_enum_register_static ("CheckState", values);
		g_once_init_leave (&check_state_type_id__volatile, check_state_type_id);
	}
	return check_state_type_id__volatile;
}


static inline gpointer
chess_state_get_instance_private (ChessState* self)
{
	return G_STRUCT_MEMBER_P (self, ChessState_private_offset);
}


static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
#line 41 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 41 "../lib/chess-state.vala"
	return self;
#line 321 "chess-state.c"
}


static ChessState*
chess_state_new_empty (void)
{
#line 41 "../lib/chess-state.vala"
	return chess_state_construct_empty (TYPE_CHESS_STATE);
#line 330 "chess-state.c"
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 348 "chess-state.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../lib/chess-state.vala"
	return self ? g_object_ref (self) : NULL;
#line 357 "chess-state.c"
}


ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	ChessPlayer* _tmp2_;
	ChessPlayer* _tmp3_;
	gchar** fields = NULL;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp57_;
	gint _tmp57__length1;
	const gchar* _tmp58_;
	gchar** _tmp65_;
	gint _tmp65__length1;
	const gchar* _tmp66_;
	gchar** _tmp85_;
	gint _tmp85__length1;
	const gchar* _tmp86_;
	gchar** _tmp91_;
	gint _tmp91__length1;
	const gchar* _tmp92_;
	gchar** _tmp93_;
	gint _tmp93__length1;
	const gchar* _tmp94_;
	ChessPlayer* _tmp95_;
	Color _tmp96_;
	ChessPlayer* _tmp98_;
#line 46 "../lib/chess-state.vala"
	g_return_val_if_fail (fen != NULL, NULL);
#line 46 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 48 "../lib/chess-state.vala"
	_tmp0_ = chess_player_new (COLOR_WHITE);
#line 48 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_WHITE]);
#line 48 "../lib/chess-state.vala"
	self->players[COLOR_WHITE] = _tmp0_;
#line 48 "../lib/chess-state.vala"
	_tmp1_ = self->players[COLOR_WHITE];
#line 49 "../lib/chess-state.vala"
	_tmp2_ = chess_player_new (COLOR_BLACK);
#line 49 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_BLACK]);
#line 49 "../lib/chess-state.vala"
	self->players[COLOR_BLACK] = _tmp2_;
#line 49 "../lib/chess-state.vala"
	_tmp3_ = self->players[COLOR_BLACK];
#line 421 "chess-state.c"
	{
		gint i = 0;
#line 50 "../lib/chess-state.vala"
		i = 0;
#line 426 "chess-state.c"
		{
			gboolean _tmp4_ = FALSE;
#line 50 "../lib/chess-state.vala"
			_tmp4_ = TRUE;
#line 50 "../lib/chess-state.vala"
			while (TRUE) {
#line 433 "chess-state.c"
				gint _tmp6_;
				gint _tmp7_;
				ChessPiece* _tmp8_;
#line 50 "../lib/chess-state.vala"
				if (!_tmp4_) {
#line 439 "chess-state.c"
					gint _tmp5_;
#line 50 "../lib/chess-state.vala"
					_tmp5_ = i;
#line 50 "../lib/chess-state.vala"
					i = _tmp5_ + 1;
#line 445 "chess-state.c"
				}
#line 50 "../lib/chess-state.vala"
				_tmp4_ = FALSE;
#line 50 "../lib/chess-state.vala"
				_tmp6_ = i;
#line 50 "../lib/chess-state.vala"
				if (!(_tmp6_ < 64)) {
#line 50 "../lib/chess-state.vala"
					break;
#line 455 "chess-state.c"
				}
#line 51 "../lib/chess-state.vala"
				_tmp7_ = i;
#line 51 "../lib/chess-state.vala"
				_g_object_unref0 (self->board[_tmp7_]);
#line 51 "../lib/chess-state.vala"
				self->board[_tmp7_] = NULL;
#line 51 "../lib/chess-state.vala"
				_tmp8_ = self->board[_tmp7_];
#line 465 "chess-state.c"
			}
		}
	}
#line 53 "../lib/chess-state.vala"
	_tmp10_ = _tmp9_ = g_strsplit (fen, " ", 0);
#line 53 "../lib/chess-state.vala"
	fields = _tmp10_;
#line 53 "../lib/chess-state.vala"
	fields_length1 = _vala_array_length (_tmp9_);
#line 53 "../lib/chess-state.vala"
	_fields_size_ = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp11_ = fields;
#line 58 "../lib/chess-state.vala"
	_tmp11__length1 = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp12_ = _tmp11_[0];
#line 58 "../lib/chess-state.vala"
	_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, "/", 0);
#line 58 "../lib/chess-state.vala"
	ranks = _tmp14_;
#line 58 "../lib/chess-state.vala"
	ranks_length1 = _vala_array_length (_tmp13_);
#line 58 "../lib/chess-state.vala"
	_ranks_size_ = ranks_length1;
#line 491 "chess-state.c"
	{
		gint rank = 0;
#line 61 "../lib/chess-state.vala"
		rank = 0;
#line 496 "chess-state.c"
		{
			gboolean _tmp15_ = FALSE;
#line 61 "../lib/chess-state.vala"
			_tmp15_ = TRUE;
#line 61 "../lib/chess-state.vala"
			while (TRUE) {
#line 503 "chess-state.c"
				gint _tmp17_;
				gchar* rank_string = NULL;
				gchar** _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
#line 61 "../lib/chess-state.vala"
				if (!_tmp15_) {
#line 513 "chess-state.c"
					gint _tmp16_;
#line 61 "../lib/chess-state.vala"
					_tmp16_ = rank;
#line 61 "../lib/chess-state.vala"
					rank = _tmp16_ + 1;
#line 519 "chess-state.c"
				}
#line 61 "../lib/chess-state.vala"
				_tmp15_ = FALSE;
#line 61 "../lib/chess-state.vala"
				_tmp17_ = rank;
#line 61 "../lib/chess-state.vala"
				if (!(_tmp17_ < 8)) {
#line 61 "../lib/chess-state.vala"
					break;
#line 529 "chess-state.c"
				}
#line 63 "../lib/chess-state.vala"
				_tmp18_ = ranks;
#line 63 "../lib/chess-state.vala"
				_tmp18__length1 = ranks_length1;
#line 63 "../lib/chess-state.vala"
				_tmp19_ = rank;
#line 63 "../lib/chess-state.vala"
				_tmp20_ = _tmp18_[7 - _tmp19_];
#line 63 "../lib/chess-state.vala"
				_tmp21_ = g_strdup (_tmp20_);
#line 63 "../lib/chess-state.vala"
				rank_string = _tmp21_;
#line 543 "chess-state.c"
				{
					gint file = 0;
					gint offset = 0;
#line 64 "../lib/chess-state.vala"
					file = 0;
#line 64 "../lib/chess-state.vala"
					offset = 0;
#line 551 "chess-state.c"
					{
						gboolean _tmp22_ = FALSE;
#line 64 "../lib/chess-state.vala"
						_tmp22_ = TRUE;
#line 64 "../lib/chess-state.vala"
						while (TRUE) {
#line 558 "chess-state.c"
							gboolean _tmp24_ = FALSE;
							gint _tmp25_;
							gchar c = '\0';
							const gchar* _tmp30_;
							gint _tmp31_;
							gboolean _tmp32_ = FALSE;
							gchar _tmp33_;
							PieceType type = 0;
							Color _tmp37_ = 0;
							gchar _tmp38_;
							Color color = 0;
							gchar _tmp39_;
							PieceType _tmp40_ = 0;
							gint index = 0;
							gint _tmp41_;
							gint _tmp42_;
							ChessPiece* piece = NULL;
							Color _tmp43_;
							ChessPlayer* _tmp44_;
							PieceType _tmp45_;
							ChessPiece* _tmp46_;
							gint _tmp47_;
							ChessPiece* _tmp48_;
							ChessPiece* _tmp49_;
							ChessPiece* _tmp50_;
							gint64 mask = 0LL;
							gint _tmp51_;
							gint64 _tmp52_;
							Color _tmp53_;
							gint64 _tmp54_;
							gint64 _tmp55_;
							gint _tmp56_;
#line 64 "../lib/chess-state.vala"
							if (!_tmp22_) {
#line 593 "chess-state.c"
								gint _tmp23_;
#line 64 "../lib/chess-state.vala"
								_tmp23_ = offset;
#line 64 "../lib/chess-state.vala"
								offset = _tmp23_ + 1;
#line 599 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							_tmp22_ = FALSE;
#line 64 "../lib/chess-state.vala"
							_tmp25_ = file;
#line 64 "../lib/chess-state.vala"
							if (_tmp25_ < 8) {
#line 607 "chess-state.c"
								gint _tmp26_;
								const gchar* _tmp27_;
								gint _tmp28_;
								gint _tmp29_;
#line 64 "../lib/chess-state.vala"
								_tmp26_ = offset;
#line 64 "../lib/chess-state.vala"
								_tmp27_ = rank_string;
#line 64 "../lib/chess-state.vala"
								_tmp28_ = strlen (_tmp27_);
#line 64 "../lib/chess-state.vala"
								_tmp29_ = _tmp28_;
#line 64 "../lib/chess-state.vala"
								_tmp24_ = _tmp26_ < _tmp29_;
#line 622 "chess-state.c"
							} else {
#line 64 "../lib/chess-state.vala"
								_tmp24_ = FALSE;
#line 626 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							if (!_tmp24_) {
#line 64 "../lib/chess-state.vala"
								break;
#line 632 "chess-state.c"
							}
#line 66 "../lib/chess-state.vala"
							_tmp30_ = rank_string;
#line 66 "../lib/chess-state.vala"
							_tmp31_ = offset;
#line 66 "../lib/chess-state.vala"
							c = string_get (_tmp30_, (glong) _tmp31_);
#line 67 "../lib/chess-state.vala"
							_tmp33_ = c;
#line 67 "../lib/chess-state.vala"
							if (_tmp33_ >= '1') {
#line 644 "chess-state.c"
								gchar _tmp34_;
#line 67 "../lib/chess-state.vala"
								_tmp34_ = c;
#line 67 "../lib/chess-state.vala"
								_tmp32_ = _tmp34_ <= '8';
#line 650 "chess-state.c"
							} else {
#line 67 "../lib/chess-state.vala"
								_tmp32_ = FALSE;
#line 654 "chess-state.c"
							}
#line 67 "../lib/chess-state.vala"
							if (_tmp32_) {
#line 658 "chess-state.c"
								gint _tmp35_;
								gchar _tmp36_;
#line 69 "../lib/chess-state.vala"
								_tmp35_ = file;
#line 69 "../lib/chess-state.vala"
								_tmp36_ = c;
#line 69 "../lib/chess-state.vala"
								file = _tmp35_ + (_tmp36_ - '0');
#line 70 "../lib/chess-state.vala"
								continue;
#line 669 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							_tmp38_ = c;
#line 74 "../lib/chess-state.vala"
							if (g_ascii_isupper (_tmp38_)) {
#line 74 "../lib/chess-state.vala"
								_tmp37_ = COLOR_WHITE;
#line 677 "chess-state.c"
							} else {
#line 74 "../lib/chess-state.vala"
								_tmp37_ = COLOR_BLACK;
#line 681 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							color = _tmp37_;
#line 75 "../lib/chess-state.vala"
							_tmp39_ = c;
#line 75 "../lib/chess-state.vala"
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (_tmp39_), &_tmp40_);
#line 75 "../lib/chess-state.vala"
							type = _tmp40_;
#line 78 "../lib/chess-state.vala"
							_tmp41_ = rank;
#line 78 "../lib/chess-state.vala"
							_tmp42_ = file;
#line 78 "../lib/chess-state.vala"
							index = chess_state_get_index (self, _tmp41_, _tmp42_);
#line 79 "../lib/chess-state.vala"
							_tmp43_ = color;
#line 79 "../lib/chess-state.vala"
							_tmp44_ = self->players[_tmp43_];
#line 79 "../lib/chess-state.vala"
							_tmp45_ = type;
#line 79 "../lib/chess-state.vala"
							_tmp46_ = chess_piece_new (_tmp44_, _tmp45_);
#line 79 "../lib/chess-state.vala"
							piece = _tmp46_;
#line 80 "../lib/chess-state.vala"
							_tmp47_ = index;
#line 80 "../lib/chess-state.vala"
							_tmp48_ = piece;
#line 80 "../lib/chess-state.vala"
							_tmp49_ = _g_object_ref0 (_tmp48_);
#line 80 "../lib/chess-state.vala"
							_g_object_unref0 (self->board[_tmp47_]);
#line 80 "../lib/chess-state.vala"
							self->board[_tmp47_] = _tmp49_;
#line 80 "../lib/chess-state.vala"
							_tmp50_ = self->board[_tmp47_];
#line 81 "../lib/chess-state.vala"
							_tmp51_ = index;
#line 81 "../lib/chess-state.vala"
							_tmp52_ = BIT_BOARD_set_location_masks[_tmp51_];
#line 81 "../lib/chess-state.vala"
							mask = _tmp52_;
#line 82 "../lib/chess-state.vala"
							_tmp53_ = color;
#line 82 "../lib/chess-state.vala"
							_tmp54_ = mask;
#line 82 "../lib/chess-state.vala"
							self->priv->piece_masks[_tmp53_] |= _tmp54_;
#line 82 "../lib/chess-state.vala"
							_tmp55_ = self->priv->piece_masks[_tmp53_];
#line 83 "../lib/chess-state.vala"
							_tmp56_ = file;
#line 83 "../lib/chess-state.vala"
							file = _tmp56_ + 1;
#line 64 "../lib/chess-state.vala"
							_g_object_unref0 (piece);
#line 739 "chess-state.c"
						}
					}
				}
#line 61 "../lib/chess-state.vala"
				_g_free0 (rank_string);
#line 745 "chess-state.c"
			}
		}
	}
#line 88 "../lib/chess-state.vala"
	_tmp57_ = fields;
#line 88 "../lib/chess-state.vala"
	_tmp57__length1 = fields_length1;
#line 88 "../lib/chess-state.vala"
	_tmp58_ = _tmp57_[1];
#line 88 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp58_, "w") == 0) {
#line 757 "chess-state.c"
		ChessPlayer* _tmp59_;
		ChessPlayer* _tmp60_;
#line 89 "../lib/chess-state.vala"
		_tmp59_ = self->players[COLOR_WHITE];
#line 89 "../lib/chess-state.vala"
		_tmp60_ = _g_object_ref0 (_tmp59_);
#line 89 "../lib/chess-state.vala"
		_g_object_unref0 (self->current_player);
#line 89 "../lib/chess-state.vala"
		self->current_player = _tmp60_;
#line 768 "chess-state.c"
	} else {
		gchar** _tmp61_;
		gint _tmp61__length1;
		const gchar* _tmp62_;
#line 90 "../lib/chess-state.vala"
		_tmp61_ = fields;
#line 90 "../lib/chess-state.vala"
		_tmp61__length1 = fields_length1;
#line 90 "../lib/chess-state.vala"
		_tmp62_ = _tmp61_[1];
#line 90 "../lib/chess-state.vala"
		if (g_strcmp0 (_tmp62_, "b") == 0) {
#line 781 "chess-state.c"
			ChessPlayer* _tmp63_;
			ChessPlayer* _tmp64_;
#line 91 "../lib/chess-state.vala"
			_tmp63_ = self->players[COLOR_BLACK];
#line 91 "../lib/chess-state.vala"
			_tmp64_ = _g_object_ref0 (_tmp63_);
#line 91 "../lib/chess-state.vala"
			_g_object_unref0 (self->current_player);
#line 91 "../lib/chess-state.vala"
			self->current_player = _tmp64_;
#line 792 "chess-state.c"
		}
	}
#line 96 "../lib/chess-state.vala"
	_tmp65_ = fields;
#line 96 "../lib/chess-state.vala"
	_tmp65__length1 = fields_length1;
#line 96 "../lib/chess-state.vala"
	_tmp66_ = _tmp65_[2];
#line 96 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp66_, "-") != 0) {
#line 803 "chess-state.c"
		{
			gint i = 0;
#line 98 "../lib/chess-state.vala"
			i = 0;
#line 808 "chess-state.c"
			{
				gboolean _tmp67_ = FALSE;
#line 98 "../lib/chess-state.vala"
				_tmp67_ = TRUE;
#line 98 "../lib/chess-state.vala"
				while (TRUE) {
#line 815 "chess-state.c"
					gint _tmp69_;
					gchar** _tmp70_;
					gint _tmp70__length1;
					const gchar* _tmp71_;
					gint _tmp72_;
					gint _tmp73_;
					gchar c = '\0';
					gchar** _tmp74_;
					gint _tmp74__length1;
					const gchar* _tmp75_;
					gint _tmp76_;
					gchar _tmp77_;
#line 98 "../lib/chess-state.vala"
					if (!_tmp67_) {
#line 830 "chess-state.c"
						gint _tmp68_;
#line 98 "../lib/chess-state.vala"
						_tmp68_ = i;
#line 98 "../lib/chess-state.vala"
						i = _tmp68_ + 1;
#line 836 "chess-state.c"
					}
#line 98 "../lib/chess-state.vala"
					_tmp67_ = FALSE;
#line 98 "../lib/chess-state.vala"
					_tmp69_ = i;
#line 98 "../lib/chess-state.vala"
					_tmp70_ = fields;
#line 98 "../lib/chess-state.vala"
					_tmp70__length1 = fields_length1;
#line 98 "../lib/chess-state.vala"
					_tmp71_ = _tmp70_[2];
#line 98 "../lib/chess-state.vala"
					_tmp72_ = strlen (_tmp71_);
#line 98 "../lib/chess-state.vala"
					_tmp73_ = _tmp72_;
#line 98 "../lib/chess-state.vala"
					if (!(_tmp69_ < _tmp73_)) {
#line 98 "../lib/chess-state.vala"
						break;
#line 856 "chess-state.c"
					}
#line 100 "../lib/chess-state.vala"
					_tmp74_ = fields;
#line 100 "../lib/chess-state.vala"
					_tmp74__length1 = fields_length1;
#line 100 "../lib/chess-state.vala"
					_tmp75_ = _tmp74_[2];
#line 100 "../lib/chess-state.vala"
					_tmp76_ = i;
#line 100 "../lib/chess-state.vala"
					c = string_get (_tmp75_, (glong) _tmp76_);
#line 101 "../lib/chess-state.vala"
					_tmp77_ = c;
#line 101 "../lib/chess-state.vala"
					if (_tmp77_ == 'K') {
#line 872 "chess-state.c"
						gboolean _tmp78_;
#line 102 "../lib/chess-state.vala"
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
#line 102 "../lib/chess-state.vala"
						_tmp78_ = self->can_castle_kingside[COLOR_WHITE];
#line 878 "chess-state.c"
					} else {
						gchar _tmp79_;
#line 103 "../lib/chess-state.vala"
						_tmp79_ = c;
#line 103 "../lib/chess-state.vala"
						if (_tmp79_ == 'Q') {
#line 885 "chess-state.c"
							gboolean _tmp80_;
#line 104 "../lib/chess-state.vala"
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
#line 104 "../lib/chess-state.vala"
							_tmp80_ = self->can_castle_queenside[COLOR_WHITE];
#line 891 "chess-state.c"
						} else {
							gchar _tmp81_;
#line 105 "../lib/chess-state.vala"
							_tmp81_ = c;
#line 105 "../lib/chess-state.vala"
							if (_tmp81_ == 'k') {
#line 898 "chess-state.c"
								gboolean _tmp82_;
#line 106 "../lib/chess-state.vala"
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
#line 106 "../lib/chess-state.vala"
								_tmp82_ = self->can_castle_kingside[COLOR_BLACK];
#line 904 "chess-state.c"
							} else {
								gchar _tmp83_;
#line 107 "../lib/chess-state.vala"
								_tmp83_ = c;
#line 107 "../lib/chess-state.vala"
								if (_tmp83_ == 'q') {
#line 911 "chess-state.c"
									gboolean _tmp84_;
#line 108 "../lib/chess-state.vala"
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
#line 108 "../lib/chess-state.vala"
									_tmp84_ = self->can_castle_queenside[COLOR_BLACK];
#line 917 "chess-state.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 115 "../lib/chess-state.vala"
	_tmp85_ = fields;
#line 115 "../lib/chess-state.vala"
	_tmp85__length1 = fields_length1;
#line 115 "../lib/chess-state.vala"
	_tmp86_ = _tmp85_[3];
#line 115 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp86_, "-") != 0) {
#line 934 "chess-state.c"
		gchar** _tmp87_;
		gint _tmp87__length1;
		const gchar* _tmp88_;
		gchar** _tmp89_;
		gint _tmp89__length1;
		const gchar* _tmp90_;
#line 119 "../lib/chess-state.vala"
		_tmp87_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp87__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp88_ = _tmp87_[3];
#line 119 "../lib/chess-state.vala"
		_tmp89_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp89__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp90_ = _tmp89_[3];
#line 119 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp88_, (glong) 1) - '1'), (gint) (string_get (_tmp90_, (glong) 0) - 'a'));
#line 955 "chess-state.c"
	}
#line 123 "../lib/chess-state.vala"
	_tmp91_ = fields;
#line 123 "../lib/chess-state.vala"
	_tmp91__length1 = fields_length1;
#line 123 "../lib/chess-state.vala"
	_tmp92_ = _tmp91_[4];
#line 123 "../lib/chess-state.vala"
	self->halfmove_clock = atoi (_tmp92_);
#line 126 "../lib/chess-state.vala"
	_tmp93_ = fields;
#line 126 "../lib/chess-state.vala"
	_tmp93__length1 = fields_length1;
#line 126 "../lib/chess-state.vala"
	_tmp94_ = _tmp93_[5];
#line 126 "../lib/chess-state.vala"
	self->number = (atoi (_tmp94_) - 1) * 2;
#line 127 "../lib/chess-state.vala"
	_tmp95_ = self->current_player;
#line 127 "../lib/chess-state.vala"
	_tmp96_ = _tmp95_->color;
#line 127 "../lib/chess-state.vala"
	if (_tmp96_ == COLOR_BLACK) {
#line 979 "chess-state.c"
		gint _tmp97_;
#line 128 "../lib/chess-state.vala"
		_tmp97_ = self->number;
#line 128 "../lib/chess-state.vala"
		self->number = _tmp97_ + 1;
#line 985 "chess-state.c"
	}
#line 130 "../lib/chess-state.vala"
	_tmp98_ = self->current_player;
#line 130 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp98_);
#line 46 "../lib/chess-state.vala"
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	return self;
#line 997 "chess-state.c"
}


ChessState*
chess_state_new (const gchar* fen)
{
#line 46 "../lib/chess-state.vala"
	return chess_state_construct (TYPE_CHESS_STATE, fen);
#line 1006 "chess-state.c"
}


ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* result = NULL;
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	gint _tmp2_;
	ChessState* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessPlayer* _tmp5_;
	ChessPlayer* _tmp6_;
	ChessState* _tmp7_;
	ChessPlayer* _tmp8_;
	ChessPlayer* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessState* _tmp11_;
	ChessPlayer* _tmp12_;
	ChessPlayer* _tmp13_;
	ChessState* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	ChessState* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	ChessState* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	ChessState* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	ChessState* _tmp26_;
	gint _tmp27_;
	ChessState* _tmp28_;
	CheckState _tmp29_;
	ChessMove* _tmp30_;
	ChessState* _tmp43_;
	gint64 _tmp44_;
	gint64 _tmp45_;
	ChessState* _tmp46_;
	gint64 _tmp47_;
	gint64 _tmp48_;
	ChessState* _tmp49_;
	gint _tmp50_;
#line 133 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../lib/chess-state.vala"
	_tmp0_ = chess_state_new_empty ();
#line 135 "../lib/chess-state.vala"
	state = _tmp0_;
#line 137 "../lib/chess-state.vala"
	_tmp1_ = state;
#line 137 "../lib/chess-state.vala"
	_tmp2_ = self->number;
#line 137 "../lib/chess-state.vala"
	_tmp1_->number = _tmp2_;
#line 138 "../lib/chess-state.vala"
	_tmp3_ = state;
#line 138 "../lib/chess-state.vala"
	_tmp4_ = self->players[COLOR_WHITE];
#line 138 "../lib/chess-state.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 138 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp3_->players[COLOR_WHITE]);
#line 138 "../lib/chess-state.vala"
	_tmp3_->players[COLOR_WHITE] = _tmp5_;
#line 138 "../lib/chess-state.vala"
	_tmp6_ = _tmp3_->players[COLOR_WHITE];
#line 139 "../lib/chess-state.vala"
	_tmp7_ = state;
#line 139 "../lib/chess-state.vala"
	_tmp8_ = self->players[COLOR_BLACK];
#line 139 "../lib/chess-state.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 139 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp7_->players[COLOR_BLACK]);
#line 139 "../lib/chess-state.vala"
	_tmp7_->players[COLOR_BLACK] = _tmp9_;
#line 139 "../lib/chess-state.vala"
	_tmp10_ = _tmp7_->players[COLOR_BLACK];
#line 140 "../lib/chess-state.vala"
	_tmp11_ = state;
#line 140 "../lib/chess-state.vala"
	_tmp12_ = self->current_player;
#line 140 "../lib/chess-state.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 140 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp11_->current_player);
#line 140 "../lib/chess-state.vala"
	_tmp11_->current_player = _tmp13_;
#line 141 "../lib/chess-state.vala"
	_tmp14_ = state;
#line 141 "../lib/chess-state.vala"
	_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
#line 141 "../lib/chess-state.vala"
	_tmp14_->can_castle_kingside[COLOR_WHITE] = _tmp15_;
#line 141 "../lib/chess-state.vala"
	_tmp16_ = _tmp14_->can_castle_kingside[COLOR_WHITE];
#line 142 "../lib/chess-state.vala"
	_tmp17_ = state;
#line 142 "../lib/chess-state.vala"
	_tmp18_ = self->can_castle_queenside[COLOR_WHITE];
#line 142 "../lib/chess-state.vala"
	_tmp17_->can_castle_queenside[COLOR_WHITE] = _tmp18_;
#line 142 "../lib/chess-state.vala"
	_tmp19_ = _tmp17_->can_castle_queenside[COLOR_WHITE];
#line 143 "../lib/chess-state.vala"
	_tmp20_ = state;
#line 143 "../lib/chess-state.vala"
	_tmp21_ = self->can_castle_kingside[COLOR_BLACK];
#line 143 "../lib/chess-state.vala"
	_tmp20_->can_castle_kingside[COLOR_BLACK] = _tmp21_;
#line 143 "../lib/chess-state.vala"
	_tmp22_ = _tmp20_->can_castle_kingside[COLOR_BLACK];
#line 144 "../lib/chess-state.vala"
	_tmp23_ = state;
#line 144 "../lib/chess-state.vala"
	_tmp24_ = self->can_castle_queenside[COLOR_BLACK];
#line 144 "../lib/chess-state.vala"
	_tmp23_->can_castle_queenside[COLOR_BLACK] = _tmp24_;
#line 144 "../lib/chess-state.vala"
	_tmp25_ = _tmp23_->can_castle_queenside[COLOR_BLACK];
#line 145 "../lib/chess-state.vala"
	_tmp26_ = state;
#line 145 "../lib/chess-state.vala"
	_tmp27_ = self->en_passant_index;
#line 145 "../lib/chess-state.vala"
	_tmp26_->en_passant_index = _tmp27_;
#line 146 "../lib/chess-state.vala"
	_tmp28_ = state;
#line 146 "../lib/chess-state.vala"
	_tmp29_ = self->check_state;
#line 146 "../lib/chess-state.vala"
	_tmp28_->check_state = _tmp29_;
#line 147 "../lib/chess-state.vala"
	_tmp30_ = self->last_move;
#line 147 "../lib/chess-state.vala"
	if (_tmp30_ != NULL) {
#line 1148 "chess-state.c"
		ChessState* _tmp31_;
		ChessMove* _tmp32_;
		ChessMove* _tmp33_;
#line 148 "../lib/chess-state.vala"
		_tmp31_ = state;
#line 148 "../lib/chess-state.vala"
		_tmp32_ = self->last_move;
#line 148 "../lib/chess-state.vala"
		_tmp33_ = chess_move_copy (_tmp32_);
#line 148 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp31_->last_move);
#line 148 "../lib/chess-state.vala"
		_tmp31_->last_move = _tmp33_;
#line 1162 "chess-state.c"
	}
	{
		gint i = 0;
#line 149 "../lib/chess-state.vala"
		i = 0;
#line 1168 "chess-state.c"
		{
			gboolean _tmp34_ = FALSE;
#line 149 "../lib/chess-state.vala"
			_tmp34_ = TRUE;
#line 149 "../lib/chess-state.vala"
			while (TRUE) {
#line 1175 "chess-state.c"
				gint _tmp36_;
				ChessState* _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				ChessPiece* _tmp40_;
				ChessPiece* _tmp41_;
				ChessPiece* _tmp42_;
#line 149 "../lib/chess-state.vala"
				if (!_tmp34_) {
#line 1185 "chess-state.c"
					gint _tmp35_;
#line 149 "../lib/chess-state.vala"
					_tmp35_ = i;
#line 149 "../lib/chess-state.vala"
					i = _tmp35_ + 1;
#line 1191 "chess-state.c"
				}
#line 149 "../lib/chess-state.vala"
				_tmp34_ = FALSE;
#line 149 "../lib/chess-state.vala"
				_tmp36_ = i;
#line 149 "../lib/chess-state.vala"
				if (!(_tmp36_ < 64)) {
#line 149 "../lib/chess-state.vala"
					break;
#line 1201 "chess-state.c"
				}
#line 150 "../lib/chess-state.vala"
				_tmp37_ = state;
#line 150 "../lib/chess-state.vala"
				_tmp38_ = i;
#line 150 "../lib/chess-state.vala"
				_tmp39_ = i;
#line 150 "../lib/chess-state.vala"
				_tmp40_ = self->board[_tmp39_];
#line 150 "../lib/chess-state.vala"
				_tmp41_ = _g_object_ref0 (_tmp40_);
#line 150 "../lib/chess-state.vala"
				_g_object_unref0 (_tmp37_->board[_tmp38_]);
#line 150 "../lib/chess-state.vala"
				_tmp37_->board[_tmp38_] = _tmp41_;
#line 150 "../lib/chess-state.vala"
				_tmp42_ = _tmp37_->board[_tmp38_];
#line 1219 "chess-state.c"
			}
		}
	}
#line 151 "../lib/chess-state.vala"
	_tmp43_ = state;
#line 151 "../lib/chess-state.vala"
	_tmp44_ = self->priv->piece_masks[COLOR_WHITE];
#line 151 "../lib/chess-state.vala"
	_tmp43_->priv->piece_masks[COLOR_WHITE] = _tmp44_;
#line 151 "../lib/chess-state.vala"
	_tmp45_ = _tmp43_->priv->piece_masks[COLOR_WHITE];
#line 152 "../lib/chess-state.vala"
	_tmp46_ = state;
#line 152 "../lib/chess-state.vala"
	_tmp47_ = self->priv->piece_masks[COLOR_BLACK];
#line 152 "../lib/chess-state.vala"
	_tmp46_->priv->piece_masks[COLOR_BLACK] = _tmp47_;
#line 152 "../lib/chess-state.vala"
	_tmp48_ = _tmp46_->priv->piece_masks[COLOR_BLACK];
#line 153 "../lib/chess-state.vala"
	_tmp49_ = state;
#line 153 "../lib/chess-state.vala"
	_tmp50_ = self->halfmove_clock;
#line 153 "../lib/chess-state.vala"
	_tmp49_->halfmove_clock = _tmp50_;
#line 155 "../lib/chess-state.vala"
	result = state;
#line 155 "../lib/chess-state.vala"
	return result;
#line 1249 "chess-state.c"
}


gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 168 "../lib/chess-state.vala"
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	if (_tmp7_ != _tmp8_) {
#line 168 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 1279 "chess-state.c"
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
#line 169 "../lib/chess-state.vala"
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != _tmp10_;
#line 1289 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 168 "../lib/chess-state.vala"
		_tmp5_ = TRUE;
#line 1295 "chess-state.c"
	} else {
		ChessPlayer* _tmp11_;
		Color _tmp12_;
		ChessPlayer* _tmp13_;
		Color _tmp14_;
#line 170 "../lib/chess-state.vala"
		_tmp11_ = self->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp12_ = _tmp11_->color;
#line 170 "../lib/chess-state.vala"
		_tmp13_ = state->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp14_ = _tmp13_->color;
#line 170 "../lib/chess-state.vala"
		_tmp5_ = _tmp12_ != _tmp14_;
#line 1311 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 168 "../lib/chess-state.vala"
		_tmp4_ = TRUE;
#line 1317 "chess-state.c"
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 171 "../lib/chess-state.vala"
		_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp16_ = state->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp4_ = _tmp15_ != _tmp16_;
#line 1327 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 168 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 1333 "chess-state.c"
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 172 "../lib/chess-state.vala"
		_tmp17_ = self->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp18_ = state->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp3_ = _tmp17_ != _tmp18_;
#line 1343 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 168 "../lib/chess-state.vala"
		_tmp2_ = TRUE;
#line 1349 "chess-state.c"
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 173 "../lib/chess-state.vala"
		_tmp19_ = self->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp20_ = state->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp2_ = _tmp19_ != _tmp20_;
#line 1359 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 168 "../lib/chess-state.vala"
		_tmp1_ = TRUE;
#line 1365 "chess-state.c"
	} else {
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 174 "../lib/chess-state.vala"
		_tmp21_ = self->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp22_ = state->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp1_ = _tmp21_ != _tmp22_;
#line 1375 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp1_) {
#line 168 "../lib/chess-state.vala"
		_tmp0_ = TRUE;
#line 1381 "chess-state.c"
	} else {
		gint _tmp23_;
		gint _tmp24_;
#line 175 "../lib/chess-state.vala"
		_tmp23_ = self->en_passant_index;
#line 175 "../lib/chess-state.vala"
		_tmp24_ = state->en_passant_index;
#line 175 "../lib/chess-state.vala"
		_tmp0_ = _tmp23_ != _tmp24_;
#line 1391 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp0_) {
#line 176 "../lib/chess-state.vala"
		result = FALSE;
#line 176 "../lib/chess-state.vala"
		return result;
#line 1399 "chess-state.c"
	}
	{
		gint i = 0;
#line 179 "../lib/chess-state.vala"
		i = 0;
#line 1405 "chess-state.c"
		{
			gboolean _tmp25_ = FALSE;
#line 179 "../lib/chess-state.vala"
			_tmp25_ = TRUE;
#line 179 "../lib/chess-state.vala"
			while (TRUE) {
#line 1412 "chess-state.c"
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				ChessPiece* _tmp30_;
#line 179 "../lib/chess-state.vala"
				if (!_tmp25_) {
#line 1419 "chess-state.c"
					gint _tmp26_;
#line 179 "../lib/chess-state.vala"
					_tmp26_ = i;
#line 179 "../lib/chess-state.vala"
					i = _tmp26_ + 1;
#line 1425 "chess-state.c"
				}
#line 179 "../lib/chess-state.vala"
				_tmp25_ = FALSE;
#line 179 "../lib/chess-state.vala"
				_tmp27_ = i;
#line 179 "../lib/chess-state.vala"
				if (!(_tmp27_ < 64)) {
#line 179 "../lib/chess-state.vala"
					break;
#line 1435 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				_tmp29_ = i;
#line 181 "../lib/chess-state.vala"
				_tmp30_ = self->board[_tmp29_];
#line 181 "../lib/chess-state.vala"
				if (_tmp30_ != NULL) {
#line 1443 "chess-state.c"
					gint _tmp31_;
					ChessPiece* _tmp32_;
					PieceType _tmp33_;
					gint _tmp34_;
					ChessPiece* _tmp35_;
					PieceType _tmp36_;
#line 181 "../lib/chess-state.vala"
					_tmp31_ = i;
#line 181 "../lib/chess-state.vala"
					_tmp32_ = self->board[_tmp31_];
#line 181 "../lib/chess-state.vala"
					_tmp33_ = _tmp32_->type;
#line 181 "../lib/chess-state.vala"
					_tmp34_ = i;
#line 181 "../lib/chess-state.vala"
					_tmp35_ = state->board[_tmp34_];
#line 181 "../lib/chess-state.vala"
					_tmp36_ = _tmp35_->type;
#line 181 "../lib/chess-state.vala"
					_tmp28_ = _tmp33_ != _tmp36_;
#line 1464 "chess-state.c"
				} else {
#line 181 "../lib/chess-state.vala"
					_tmp28_ = FALSE;
#line 1468 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				if (_tmp28_) {
#line 182 "../lib/chess-state.vala"
					result = FALSE;
#line 182 "../lib/chess-state.vala"
					return result;
#line 1476 "chess-state.c"
				}
			}
		}
	}
#line 185 "../lib/chess-state.vala"
	result = TRUE;
#line 185 "../lib/chess-state.vala"
	return result;
#line 1485 "chess-state.c"
}


gchar*
chess_state_get_fen (ChessState* self)
{
	gchar* result = NULL;
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp25_;
	ChessPlayer* _tmp26_;
	Color _tmp27_;
	GString* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp33_;
	gboolean _tmp35_;
	gboolean _tmp37_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GString* _tmp44_;
	gint _tmp45_;
	GString* _tmp50_;
	GString* _tmp51_;
	gint _tmp52_;
	GString* _tmp53_;
	ChessPlayer* _tmp54_;
	Color _tmp55_;
	GString* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
#line 188 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../lib/chess-state.vala"
	_tmp0_ = g_string_new ("");
#line 190 "../lib/chess-state.vala"
	value = _tmp0_;
#line 1524 "chess-state.c"
	{
		gint rank = 0;
#line 192 "../lib/chess-state.vala"
		rank = 7;
#line 1529 "chess-state.c"
		{
			gboolean _tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
			_tmp1_ = TRUE;
#line 192 "../lib/chess-state.vala"
			while (TRUE) {
#line 1536 "chess-state.c"
				gint _tmp3_;
				gint skip_count = 0;
				gint _tmp20_;
				gint _tmp23_;
#line 192 "../lib/chess-state.vala"
				if (!_tmp1_) {
#line 1543 "chess-state.c"
					gint _tmp2_;
#line 192 "../lib/chess-state.vala"
					_tmp2_ = rank;
#line 192 "../lib/chess-state.vala"
					rank = _tmp2_ - 1;
#line 1549 "chess-state.c"
				}
#line 192 "../lib/chess-state.vala"
				_tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
				_tmp3_ = rank;
#line 192 "../lib/chess-state.vala"
				if (!(_tmp3_ >= 0)) {
#line 192 "../lib/chess-state.vala"
					break;
#line 1559 "chess-state.c"
				}
#line 194 "../lib/chess-state.vala"
				skip_count = 0;
#line 1563 "chess-state.c"
				{
					gint file = 0;
#line 195 "../lib/chess-state.vala"
					file = 0;
#line 1568 "chess-state.c"
					{
						gboolean _tmp4_ = FALSE;
#line 195 "../lib/chess-state.vala"
						_tmp4_ = TRUE;
#line 195 "../lib/chess-state.vala"
						while (TRUE) {
#line 1575 "chess-state.c"
							gint _tmp6_;
							ChessPiece* p = NULL;
							gint _tmp7_;
							gint _tmp8_;
							ChessPiece* _tmp9_;
							ChessPiece* _tmp10_;
							ChessPiece* _tmp11_;
#line 195 "../lib/chess-state.vala"
							if (!_tmp4_) {
#line 1585 "chess-state.c"
								gint _tmp5_;
#line 195 "../lib/chess-state.vala"
								_tmp5_ = file;
#line 195 "../lib/chess-state.vala"
								file = _tmp5_ + 1;
#line 1591 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_tmp4_ = FALSE;
#line 195 "../lib/chess-state.vala"
							_tmp6_ = file;
#line 195 "../lib/chess-state.vala"
							if (!(_tmp6_ < 8)) {
#line 195 "../lib/chess-state.vala"
								break;
#line 1601 "chess-state.c"
							}
#line 197 "../lib/chess-state.vala"
							_tmp7_ = rank;
#line 197 "../lib/chess-state.vala"
							_tmp8_ = file;
#line 197 "../lib/chess-state.vala"
							_tmp9_ = self->board[chess_state_get_index (self, _tmp7_, _tmp8_)];
#line 197 "../lib/chess-state.vala"
							_tmp10_ = _g_object_ref0 (_tmp9_);
#line 197 "../lib/chess-state.vala"
							p = _tmp10_;
#line 198 "../lib/chess-state.vala"
							_tmp11_ = p;
#line 198 "../lib/chess-state.vala"
							if (_tmp11_ == NULL) {
#line 1617 "chess-state.c"
								gint _tmp12_;
#line 199 "../lib/chess-state.vala"
								_tmp12_ = skip_count;
#line 199 "../lib/chess-state.vala"
								skip_count = _tmp12_ + 1;
#line 1623 "chess-state.c"
							} else {
								gint _tmp13_;
								GString* _tmp16_;
								ChessPiece* _tmp17_;
								gunichar _tmp18_;
								gunichar _tmp19_;
#line 202 "../lib/chess-state.vala"
								_tmp13_ = skip_count;
#line 202 "../lib/chess-state.vala"
								if (_tmp13_ > 0) {
#line 1634 "chess-state.c"
									GString* _tmp14_;
									gint _tmp15_;
#line 204 "../lib/chess-state.vala"
									_tmp14_ = value;
#line 204 "../lib/chess-state.vala"
									_tmp15_ = skip_count;
#line 204 "../lib/chess-state.vala"
									g_string_append_printf (_tmp14_, "%d", _tmp15_);
#line 205 "../lib/chess-state.vala"
									skip_count = 0;
#line 1645 "chess-state.c"
								}
#line 207 "../lib/chess-state.vala"
								_tmp16_ = value;
#line 207 "../lib/chess-state.vala"
								_tmp17_ = p;
#line 207 "../lib/chess-state.vala"
								_tmp18_ = chess_piece_get_symbol (_tmp17_);
#line 207 "../lib/chess-state.vala"
								_tmp19_ = _tmp18_;
#line 207 "../lib/chess-state.vala"
								g_string_append_printf (_tmp16_, "%c", (gint) _tmp19_);
#line 1657 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 1661 "chess-state.c"
						}
					}
				}
#line 210 "../lib/chess-state.vala"
				_tmp20_ = skip_count;
#line 210 "../lib/chess-state.vala"
				if (_tmp20_ > 0) {
#line 1669 "chess-state.c"
					GString* _tmp21_;
					gint _tmp22_;
#line 211 "../lib/chess-state.vala"
					_tmp21_ = value;
#line 211 "../lib/chess-state.vala"
					_tmp22_ = skip_count;
#line 211 "../lib/chess-state.vala"
					g_string_append_printf (_tmp21_, "%d", _tmp22_);
#line 1678 "chess-state.c"
				}
#line 212 "../lib/chess-state.vala"
				_tmp23_ = rank;
#line 212 "../lib/chess-state.vala"
				if (_tmp23_ != 0) {
#line 1684 "chess-state.c"
					GString* _tmp24_;
#line 213 "../lib/chess-state.vala"
					_tmp24_ = value;
#line 213 "../lib/chess-state.vala"
					g_string_append_c (_tmp24_, '/');
#line 1690 "chess-state.c"
				}
			}
		}
	}
#line 216 "../lib/chess-state.vala"
	_tmp25_ = value;
#line 216 "../lib/chess-state.vala"
	g_string_append_c (_tmp25_, ' ');
#line 217 "../lib/chess-state.vala"
	_tmp26_ = self->current_player;
#line 217 "../lib/chess-state.vala"
	_tmp27_ = _tmp26_->color;
#line 217 "../lib/chess-state.vala"
	if (_tmp27_ == COLOR_WHITE) {
#line 1705 "chess-state.c"
		GString* _tmp28_;
#line 218 "../lib/chess-state.vala"
		_tmp28_ = value;
#line 218 "../lib/chess-state.vala"
		g_string_append_c (_tmp28_, 'w');
#line 1711 "chess-state.c"
	} else {
		GString* _tmp29_;
#line 220 "../lib/chess-state.vala"
		_tmp29_ = value;
#line 220 "../lib/chess-state.vala"
		g_string_append_c (_tmp29_, 'b');
#line 1718 "chess-state.c"
	}
#line 222 "../lib/chess-state.vala"
	_tmp30_ = value;
#line 222 "../lib/chess-state.vala"
	g_string_append_c (_tmp30_, ' ');
#line 223 "../lib/chess-state.vala"
	_tmp31_ = self->can_castle_kingside[COLOR_WHITE];
#line 223 "../lib/chess-state.vala"
	if (_tmp31_) {
#line 1728 "chess-state.c"
		GString* _tmp32_;
#line 224 "../lib/chess-state.vala"
		_tmp32_ = value;
#line 224 "../lib/chess-state.vala"
		g_string_append_c (_tmp32_, 'K');
#line 1734 "chess-state.c"
	}
#line 225 "../lib/chess-state.vala"
	_tmp33_ = self->can_castle_queenside[COLOR_WHITE];
#line 225 "../lib/chess-state.vala"
	if (_tmp33_) {
#line 1740 "chess-state.c"
		GString* _tmp34_;
#line 226 "../lib/chess-state.vala"
		_tmp34_ = value;
#line 226 "../lib/chess-state.vala"
		g_string_append_c (_tmp34_, 'Q');
#line 1746 "chess-state.c"
	}
#line 227 "../lib/chess-state.vala"
	_tmp35_ = self->can_castle_kingside[COLOR_BLACK];
#line 227 "../lib/chess-state.vala"
	if (_tmp35_) {
#line 1752 "chess-state.c"
		GString* _tmp36_;
#line 228 "../lib/chess-state.vala"
		_tmp36_ = value;
#line 228 "../lib/chess-state.vala"
		g_string_append_c (_tmp36_, 'k');
#line 1758 "chess-state.c"
	}
#line 229 "../lib/chess-state.vala"
	_tmp37_ = self->can_castle_queenside[COLOR_BLACK];
#line 229 "../lib/chess-state.vala"
	if (_tmp37_) {
#line 1764 "chess-state.c"
		GString* _tmp38_;
#line 230 "../lib/chess-state.vala"
		_tmp38_ = value;
#line 230 "../lib/chess-state.vala"
		g_string_append_c (_tmp38_, 'q');
#line 1770 "chess-state.c"
	}
#line 231 "../lib/chess-state.vala"
	_tmp39_ = self->can_castle_kingside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp40_ = self->can_castle_queenside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp41_ = self->can_castle_kingside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	_tmp42_ = self->can_castle_queenside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	if (!(((_tmp39_ | _tmp40_) | _tmp41_) | _tmp42_)) {
#line 1782 "chess-state.c"
		GString* _tmp43_;
#line 232 "../lib/chess-state.vala"
		_tmp43_ = value;
#line 232 "../lib/chess-state.vala"
		g_string_append_c (_tmp43_, '-');
#line 1788 "chess-state.c"
	}
#line 234 "../lib/chess-state.vala"
	_tmp44_ = value;
#line 234 "../lib/chess-state.vala"
	g_string_append_c (_tmp44_, ' ');
#line 235 "../lib/chess-state.vala"
	_tmp45_ = self->en_passant_index;
#line 235 "../lib/chess-state.vala"
	if (_tmp45_ >= 0) {
#line 1798 "chess-state.c"
		GString* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
#line 236 "../lib/chess-state.vala"
		_tmp46_ = value;
#line 236 "../lib/chess-state.vala"
		_tmp47_ = self->en_passant_index;
#line 236 "../lib/chess-state.vala"
		_tmp48_ = self->en_passant_index;
#line 236 "../lib/chess-state.vala"
		g_string_append_printf (_tmp46_, "%c%d", 'a' + chess_state_get_file (self, _tmp47_), chess_state_get_rank (self, _tmp48_) + 1);
#line 1810 "chess-state.c"
	} else {
		GString* _tmp49_;
#line 238 "../lib/chess-state.vala"
		_tmp49_ = value;
#line 238 "../lib/chess-state.vala"
		g_string_append_c (_tmp49_, '-');
#line 1817 "chess-state.c"
	}
#line 240 "../lib/chess-state.vala"
	_tmp50_ = value;
#line 240 "../lib/chess-state.vala"
	g_string_append_c (_tmp50_, ' ');
#line 241 "../lib/chess-state.vala"
	_tmp51_ = value;
#line 241 "../lib/chess-state.vala"
	_tmp52_ = self->halfmove_clock;
#line 241 "../lib/chess-state.vala"
	g_string_append_printf (_tmp51_, "%d", _tmp52_);
#line 243 "../lib/chess-state.vala"
	_tmp53_ = value;
#line 243 "../lib/chess-state.vala"
	g_string_append_c (_tmp53_, ' ');
#line 244 "../lib/chess-state.vala"
	_tmp54_ = self->current_player;
#line 244 "../lib/chess-state.vala"
	_tmp55_ = _tmp54_->color;
#line 244 "../lib/chess-state.vala"
	if (_tmp55_ == COLOR_WHITE) {
#line 1839 "chess-state.c"
		GString* _tmp56_;
		gint _tmp57_;
#line 245 "../lib/chess-state.vala"
		_tmp56_ = value;
#line 245 "../lib/chess-state.vala"
		_tmp57_ = self->number;
#line 245 "../lib/chess-state.vala"
		g_string_append_printf (_tmp56_, "%d", _tmp57_ / 2);
#line 1848 "chess-state.c"
	} else {
		GString* _tmp58_;
		gint _tmp59_;
#line 247 "../lib/chess-state.vala"
		_tmp58_ = value;
#line 247 "../lib/chess-state.vala"
		_tmp59_ = self->number;
#line 247 "../lib/chess-state.vala"
		g_string_append_printf (_tmp58_, "%d", (_tmp59_ / 2) + 1);
#line 1858 "chess-state.c"
	}
#line 249 "../lib/chess-state.vala"
	_tmp60_ = value;
#line 249 "../lib/chess-state.vala"
	_tmp61_ = _tmp60_->str;
#line 249 "../lib/chess-state.vala"
	_tmp62_ = g_strdup (_tmp61_);
#line 249 "../lib/chess-state.vala"
	result = _tmp62_;
#line 249 "../lib/chess-state.vala"
	_g_string_free0 (value);
#line 249 "../lib/chess-state.vala"
	return result;
#line 1872 "chess-state.c"
}


gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result = 0;
#line 252 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 254 "../lib/chess-state.vala"
	result = (rank * 8) + file;
#line 254 "../lib/chess-state.vala"
	return result;
#line 1888 "chess-state.c"
}


gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result = 0;
#line 257 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../lib/chess-state.vala"
	result = index / 8;
#line 259 "../lib/chess-state.vala"
	return result;
#line 1903 "chess-state.c"
}


gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result = 0;
#line 262 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 264 "../lib/chess-state.vala"
	result = index % 8;
#line 264 "../lib/chess-state.vala"
	return result;
#line 1918 "chess-state.c"
}


gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gboolean result = FALSE;
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	PieceType _tmp12_;
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 272 "../lib/chess-state.vala"
	_tmp0_ = self->current_player;
#line 272 "../lib/chess-state.vala"
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 272 "../lib/chess-state.vala"
	r0 = _tmp1_;
#line 272 "../lib/chess-state.vala"
	f0 = _tmp2_;
#line 272 "../lib/chess-state.vala"
	r1 = _tmp3_;
#line 272 "../lib/chess-state.vala"
	f1 = _tmp4_;
#line 272 "../lib/chess-state.vala"
	promotion_type = _tmp5_;
#line 272 "../lib/chess-state.vala"
	if (!_tmp6_) {
#line 273 "../lib/chess-state.vala"
		result = FALSE;
#line 273 "../lib/chess-state.vala"
		return result;
#line 1970 "chess-state.c"
	}
#line 275 "../lib/chess-state.vala"
	_tmp7_ = self->current_player;
#line 275 "../lib/chess-state.vala"
	_tmp8_ = r0;
#line 275 "../lib/chess-state.vala"
	_tmp9_ = f0;
#line 275 "../lib/chess-state.vala"
	_tmp10_ = r1;
#line 275 "../lib/chess-state.vala"
	_tmp11_ = f1;
#line 275 "../lib/chess-state.vala"
	_tmp12_ = promotion_type;
#line 275 "../lib/chess-state.vala"
	if (!chess_state_move_with_coords (self, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_, apply, TRUE)) {
#line 276 "../lib/chess-state.vala"
		result = FALSE;
#line 276 "../lib/chess-state.vala"
		return result;
#line 1990 "chess-state.c"
	}
#line 278 "../lib/chess-state.vala"
	result = TRUE;
#line 278 "../lib/chess-state.vala"
	return result;
#line 1996 "chess-state.c"
}


gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gboolean result = FALSE;
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_;
	Color _tmp1_ = 0;
	Color _tmp2_;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	gint _tmp3_;
	ChessPiece* _tmp4_;
	ChessPiece* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ChessPiece* _tmp7_;
	gint64 end_mask = 0LL;
	gint _tmp10_;
	gint64 _tmp11_;
	gint64 move_mask = 0LL;
	Color _tmp12_;
	ChessPiece* _tmp13_;
	PieceType _tmp14_;
	gint _tmp15_;
	gint64 _tmp16_;
	gint64 _tmp17_;
	gint64 _tmp18_;
	gint64 over_mask = 0LL;
	gint _tmp19_;
	gint _tmp20_;
	gint64 _tmp21_;
	gint64 _tmp22_;
	gint64 _tmp23_;
	gint64 _tmp24_;
	ChessPiece* victim = NULL;
	gint _tmp25_;
	ChessPiece* _tmp26_;
	ChessPiece* _tmp27_;
	gint victim_index = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	ChessPiece* _tmp30_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp33_;
	PieceType _tmp34_;
	gboolean _tmp74_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp98_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp99_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp100_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp101_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp102_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp103_;
	gint old_en_passant_index = 0;
	gint _tmp104_;
	gint old_halfmove_clock = 0;
	gint _tmp105_;
	gint _tmp106_;
	ChessPiece* _tmp107_;
	gint _tmp108_;
	gint64 _tmp109_;
	gint64 _tmp110_;
	gint _tmp111_;
	gint64 _tmp112_;
	gint64 _tmp113_;
	ChessPiece* _tmp114_;
	gboolean _tmp123_;
	Color _tmp131_;
	gint64 _tmp132_;
	gint64 _tmp133_;
	Color _tmp134_;
	gint _tmp135_;
	gint64 _tmp136_;
	gint64 _tmp137_;
	gint _tmp138_;
	ChessPiece* _tmp156_;
	PieceType _tmp157_;
	gboolean _tmp182_ = FALSE;
	ChessPiece* _tmp183_;
	PieceType _tmp184_;
	gboolean _tmp186_ = FALSE;
	ChessPiece* _tmp187_;
	PieceType _tmp188_;
	gboolean _result_ = FALSE;
	gboolean _tmp191_ = FALSE;
	gboolean _tmp192_ = FALSE;
	ChessPlayer* _tmp229_ = NULL;
	Color _tmp230_;
	ChessPlayer* _tmp233_;
	ChessPlayer* _tmp234_;
	ChessMove* _tmp235_;
	ChessMove* _tmp236_;
	gint _tmp237_;
	ChessMove* _tmp238_;
	ChessPiece* _tmp239_;
	ChessPiece* _tmp240_;
	gboolean _tmp241_;
	ChessMove* _tmp246_;
	ChessPiece* _tmp247_;
	ChessPiece* _tmp248_;
	gint _tmp249_;
	ChessMove* _tmp254_;
	ChessMove* _tmp255_;
	ChessMove* _tmp256_;
	ChessMove* _tmp257_;
	ChessMove* _tmp258_;
	gboolean _tmp259_;
	ChessMove* _tmp260_;
	gboolean _tmp261_;
	ChessMove* _tmp262_;
	gboolean _tmp263_;
	ChessMove* _tmp264_;
	CheckState _tmp265_;
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 287 "../lib/chess-state.vala"
	start = chess_state_get_index (self, r0, f0);
#line 288 "../lib/chess-state.vala"
	end = chess_state_get_index (self, r1, f1);
#line 290 "../lib/chess-state.vala"
	_tmp0_ = player->color;
#line 290 "../lib/chess-state.vala"
	color = _tmp0_;
#line 291 "../lib/chess-state.vala"
	_tmp2_ = color;
#line 291 "../lib/chess-state.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 291 "../lib/chess-state.vala"
		_tmp1_ = COLOR_BLACK;
#line 2150 "chess-state.c"
	} else {
#line 291 "../lib/chess-state.vala"
		_tmp1_ = COLOR_WHITE;
#line 2154 "chess-state.c"
	}
#line 291 "../lib/chess-state.vala"
	opponent_color = _tmp1_;
#line 294 "../lib/chess-state.vala"
	_tmp3_ = start;
#line 294 "../lib/chess-state.vala"
	_tmp4_ = self->board[_tmp3_];
#line 294 "../lib/chess-state.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 294 "../lib/chess-state.vala"
	piece = _tmp5_;
#line 295 "../lib/chess-state.vala"
	_tmp7_ = piece;
#line 295 "../lib/chess-state.vala"
	if (_tmp7_ == NULL) {
#line 295 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 2172 "chess-state.c"
	} else {
		ChessPiece* _tmp8_;
		ChessPlayer* _tmp9_;
#line 295 "../lib/chess-state.vala"
		_tmp8_ = piece;
#line 295 "../lib/chess-state.vala"
		_tmp9_ = _tmp8_->player;
#line 295 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != player;
#line 2182 "chess-state.c"
	}
#line 295 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 296 "../lib/chess-state.vala"
		result = FALSE;
#line 296 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 296 "../lib/chess-state.vala"
		return result;
#line 2192 "chess-state.c"
	}
#line 299 "../lib/chess-state.vala"
	_tmp10_ = end;
#line 299 "../lib/chess-state.vala"
	_tmp11_ = BIT_BOARD_set_location_masks[_tmp10_];
#line 299 "../lib/chess-state.vala"
	end_mask = _tmp11_;
#line 300 "../lib/chess-state.vala"
	_tmp12_ = color;
#line 300 "../lib/chess-state.vala"
	_tmp13_ = piece;
#line 300 "../lib/chess-state.vala"
	_tmp14_ = _tmp13_->type;
#line 300 "../lib/chess-state.vala"
	_tmp15_ = start;
#line 300 "../lib/chess-state.vala"
	_tmp16_ = BIT_BOARD_move_masks[(((_tmp12_ * 64) * 6) + (_tmp14_ * 64)) + _tmp15_];
#line 300 "../lib/chess-state.vala"
	move_mask = _tmp16_;
#line 301 "../lib/chess-state.vala"
	_tmp17_ = end_mask;
#line 301 "../lib/chess-state.vala"
	_tmp18_ = move_mask;
#line 301 "../lib/chess-state.vala"
	if ((_tmp17_ & _tmp18_) == ((gint64) 0)) {
#line 302 "../lib/chess-state.vala"
		result = FALSE;
#line 302 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 302 "../lib/chess-state.vala"
		return result;
#line 2224 "chess-state.c"
	}
#line 305 "../lib/chess-state.vala"
	_tmp19_ = start;
#line 305 "../lib/chess-state.vala"
	_tmp20_ = end;
#line 305 "../lib/chess-state.vala"
	_tmp21_ = BIT_BOARD_over_masks[(_tmp19_ * 64) + _tmp20_];
#line 305 "../lib/chess-state.vala"
	over_mask = _tmp21_;
#line 306 "../lib/chess-state.vala"
	_tmp22_ = over_mask;
#line 306 "../lib/chess-state.vala"
	_tmp23_ = self->priv->piece_masks[COLOR_WHITE];
#line 306 "../lib/chess-state.vala"
	_tmp24_ = self->priv->piece_masks[COLOR_BLACK];
#line 306 "../lib/chess-state.vala"
	if ((_tmp22_ & (_tmp23_ | _tmp24_)) != ((gint64) 0)) {
#line 307 "../lib/chess-state.vala"
		result = FALSE;
#line 307 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 307 "../lib/chess-state.vala"
		return result;
#line 2248 "chess-state.c"
	}
#line 310 "../lib/chess-state.vala"
	_tmp25_ = end;
#line 310 "../lib/chess-state.vala"
	_tmp26_ = self->board[_tmp25_];
#line 310 "../lib/chess-state.vala"
	_tmp27_ = _g_object_ref0 (_tmp26_);
#line 310 "../lib/chess-state.vala"
	victim = _tmp27_;
#line 311 "../lib/chess-state.vala"
	_tmp28_ = end;
#line 311 "../lib/chess-state.vala"
	victim_index = _tmp28_;
#line 314 "../lib/chess-state.vala"
	_tmp30_ = victim;
#line 314 "../lib/chess-state.vala"
	if (_tmp30_ != NULL) {
#line 2266 "chess-state.c"
		ChessPiece* _tmp31_;
		ChessPlayer* _tmp32_;
#line 314 "../lib/chess-state.vala"
		_tmp31_ = victim;
#line 314 "../lib/chess-state.vala"
		_tmp32_ = _tmp31_->player;
#line 314 "../lib/chess-state.vala"
		_tmp29_ = _tmp32_ == player;
#line 2275 "chess-state.c"
	} else {
#line 314 "../lib/chess-state.vala"
		_tmp29_ = FALSE;
#line 2279 "chess-state.c"
	}
#line 314 "../lib/chess-state.vala"
	if (_tmp29_) {
#line 315 "../lib/chess-state.vala"
		result = FALSE;
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 315 "../lib/chess-state.vala"
		return result;
#line 2291 "chess-state.c"
	}
#line 318 "../lib/chess-state.vala"
	rook_start = -1;
#line 318 "../lib/chess-state.vala"
	rook_end = -1;
#line 319 "../lib/chess-state.vala"
	is_promotion = FALSE;
#line 320 "../lib/chess-state.vala"
	en_passant = FALSE;
#line 321 "../lib/chess-state.vala"
	ambiguous_rank = FALSE;
#line 322 "../lib/chess-state.vala"
	ambiguous_file = FALSE;
#line 323 "../lib/chess-state.vala"
	_tmp33_ = piece;
#line 323 "../lib/chess-state.vala"
	_tmp34_ = _tmp33_->type;
#line 323 "../lib/chess-state.vala"
	switch (_tmp34_) {
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_PAWN:
#line 2313 "chess-state.c"
		{
			gboolean _tmp35_ = FALSE;
			ChessPiece* _tmp36_;
			gboolean _tmp45_ = FALSE;
			ChessPiece* _tmp46_;
#line 327 "../lib/chess-state.vala"
			_tmp36_ = victim;
#line 327 "../lib/chess-state.vala"
			if (_tmp36_ == NULL) {
#line 2323 "chess-state.c"
				gint _tmp37_;
				gint _tmp38_;
#line 327 "../lib/chess-state.vala"
				_tmp37_ = end;
#line 327 "../lib/chess-state.vala"
				_tmp38_ = self->en_passant_index;
#line 327 "../lib/chess-state.vala"
				_tmp35_ = _tmp37_ == _tmp38_;
#line 2332 "chess-state.c"
			} else {
#line 327 "../lib/chess-state.vala"
				_tmp35_ = FALSE;
#line 2336 "chess-state.c"
			}
#line 327 "../lib/chess-state.vala"
			if (_tmp35_) {
#line 2340 "chess-state.c"
				gint _tmp39_ = 0;
				gint _tmp40_;
				ChessPiece* _tmp41_;
				ChessPiece* _tmp42_;
#line 329 "../lib/chess-state.vala"
				en_passant = TRUE;
#line 330 "../lib/chess-state.vala"
				if (r1 == 2) {
#line 330 "../lib/chess-state.vala"
					_tmp39_ = 3;
#line 2351 "chess-state.c"
				} else {
#line 330 "../lib/chess-state.vala"
					_tmp39_ = 4;
#line 2355 "chess-state.c"
				}
#line 330 "../lib/chess-state.vala"
				victim_index = chess_state_get_index (self, _tmp39_, f1);
#line 331 "../lib/chess-state.vala"
				_tmp40_ = victim_index;
#line 331 "../lib/chess-state.vala"
				_tmp41_ = self->board[_tmp40_];
#line 331 "../lib/chess-state.vala"
				_tmp42_ = _g_object_ref0 (_tmp41_);
#line 331 "../lib/chess-state.vala"
				_g_object_unref0 (victim);
#line 331 "../lib/chess-state.vala"
				victim = _tmp42_;
#line 2369 "chess-state.c"
			}
#line 335 "../lib/chess-state.vala"
			if (f0 != f1) {
#line 2373 "chess-state.c"
				ChessPiece* _tmp43_;
#line 337 "../lib/chess-state.vala"
				_tmp43_ = victim;
#line 337 "../lib/chess-state.vala"
				if (_tmp43_ == NULL) {
#line 338 "../lib/chess-state.vala"
					result = FALSE;
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 338 "../lib/chess-state.vala"
					return result;
#line 2387 "chess-state.c"
				}
			} else {
				ChessPiece* _tmp44_;
#line 343 "../lib/chess-state.vala"
				_tmp44_ = victim;
#line 343 "../lib/chess-state.vala"
				if (_tmp44_ != NULL) {
#line 344 "../lib/chess-state.vala"
					result = FALSE;
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 344 "../lib/chess-state.vala"
					return result;
#line 2403 "chess-state.c"
				}
			}
#line 346 "../lib/chess-state.vala"
			if (r1 == 0) {
#line 346 "../lib/chess-state.vala"
				_tmp45_ = TRUE;
#line 2410 "chess-state.c"
			} else {
#line 346 "../lib/chess-state.vala"
				_tmp45_ = r1 == 7;
#line 2414 "chess-state.c"
			}
#line 346 "../lib/chess-state.vala"
			is_promotion = _tmp45_;
#line 349 "../lib/chess-state.vala"
			_tmp46_ = victim;
#line 349 "../lib/chess-state.vala"
			if (_tmp46_ != NULL) {
#line 350 "../lib/chess-state.vala"
				ambiguous_file = TRUE;
#line 2424 "chess-state.c"
			}
#line 351 "../lib/chess-state.vala"
			break;
#line 2428 "chess-state.c"
		}
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_KING:
#line 2432 "chess-state.c"
		{
#line 354 "../lib/chess-state.vala"
			if (abs (f0 - f1) > 1) {
#line 2436 "chess-state.c"
				gint _tmp47_ = 0;
				gint _tmp48_ = 0;
				ChessPiece* rook = NULL;
				gint _tmp53_;
				ChessPiece* _tmp54_;
				ChessPiece* _tmp55_;
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
				ChessPiece* _tmp58_;
				gint64 rook_over_mask = 0LL;
				gint _tmp65_;
				gint _tmp66_;
				gint64 _tmp67_;
				gint64 _tmp68_;
				gint64 _tmp69_;
				gint64 _tmp70_;
				CheckState _tmp71_;
				gint _tmp72_;
				gint _tmp73_;
#line 357 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 357 "../lib/chess-state.vala"
					_tmp47_ = 7;
#line 2460 "chess-state.c"
				} else {
#line 357 "../lib/chess-state.vala"
					_tmp47_ = 0;
#line 2464 "chess-state.c"
				}
#line 357 "../lib/chess-state.vala"
				rook_start = chess_state_get_index (self, r0, _tmp47_);
#line 358 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 358 "../lib/chess-state.vala"
					_tmp48_ = f1 - 1;
#line 2472 "chess-state.c"
				} else {
#line 358 "../lib/chess-state.vala"
					_tmp48_ = f1 + 1;
#line 2476 "chess-state.c"
				}
#line 358 "../lib/chess-state.vala"
				rook_end = chess_state_get_index (self, r0, _tmp48_);
#line 361 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 2482 "chess-state.c"
					Color _tmp49_;
					gboolean _tmp50_;
#line 363 "../lib/chess-state.vala"
					_tmp49_ = color;
#line 363 "../lib/chess-state.vala"
					_tmp50_ = self->can_castle_kingside[_tmp49_];
#line 363 "../lib/chess-state.vala"
					if (!_tmp50_) {
#line 364 "../lib/chess-state.vala"
						result = FALSE;
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 364 "../lib/chess-state.vala"
						return result;
#line 2499 "chess-state.c"
					}
				} else {
					Color _tmp51_;
					gboolean _tmp52_;
#line 368 "../lib/chess-state.vala"
					_tmp51_ = color;
#line 368 "../lib/chess-state.vala"
					_tmp52_ = self->can_castle_queenside[_tmp51_];
#line 368 "../lib/chess-state.vala"
					if (!_tmp52_) {
#line 369 "../lib/chess-state.vala"
						result = FALSE;
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 369 "../lib/chess-state.vala"
						return result;
#line 2518 "chess-state.c"
					}
				}
#line 372 "../lib/chess-state.vala"
				_tmp53_ = rook_start;
#line 372 "../lib/chess-state.vala"
				_tmp54_ = self->board[_tmp53_];
#line 372 "../lib/chess-state.vala"
				_tmp55_ = _g_object_ref0 (_tmp54_);
#line 372 "../lib/chess-state.vala"
				rook = _tmp55_;
#line 373 "../lib/chess-state.vala"
				_tmp58_ = rook;
#line 373 "../lib/chess-state.vala"
				if (_tmp58_ == NULL) {
#line 373 "../lib/chess-state.vala"
					_tmp57_ = TRUE;
#line 2535 "chess-state.c"
				} else {
					ChessPiece* _tmp59_;
					PieceType _tmp60_;
#line 373 "../lib/chess-state.vala"
					_tmp59_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp60_ = _tmp59_->type;
#line 373 "../lib/chess-state.vala"
					_tmp57_ = _tmp60_ != PIECE_TYPE_ROOK;
#line 2545 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp57_) {
#line 373 "../lib/chess-state.vala"
					_tmp56_ = TRUE;
#line 2551 "chess-state.c"
				} else {
					ChessPiece* _tmp61_;
					Color _tmp62_;
					Color _tmp63_;
					Color _tmp64_;
#line 373 "../lib/chess-state.vala"
					_tmp61_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp62_ = chess_piece_get_color (_tmp61_);
#line 373 "../lib/chess-state.vala"
					_tmp63_ = _tmp62_;
#line 373 "../lib/chess-state.vala"
					_tmp64_ = color;
#line 373 "../lib/chess-state.vala"
					_tmp56_ = _tmp63_ != _tmp64_;
#line 2567 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp56_) {
#line 374 "../lib/chess-state.vala"
					result = FALSE;
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 374 "../lib/chess-state.vala"
					return result;
#line 2581 "chess-state.c"
				}
#line 377 "../lib/chess-state.vala"
				_tmp65_ = rook_start;
#line 377 "../lib/chess-state.vala"
				_tmp66_ = rook_end;
#line 377 "../lib/chess-state.vala"
				_tmp67_ = BIT_BOARD_over_masks[(_tmp65_ * 64) + _tmp66_];
#line 377 "../lib/chess-state.vala"
				rook_over_mask = _tmp67_;
#line 378 "../lib/chess-state.vala"
				_tmp68_ = rook_over_mask;
#line 378 "../lib/chess-state.vala"
				_tmp69_ = self->priv->piece_masks[COLOR_WHITE];
#line 378 "../lib/chess-state.vala"
				_tmp70_ = self->priv->piece_masks[COLOR_BLACK];
#line 378 "../lib/chess-state.vala"
				if ((_tmp68_ & (_tmp69_ | _tmp70_)) != ((gint64) 0)) {
#line 379 "../lib/chess-state.vala"
					result = FALSE;
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 379 "../lib/chess-state.vala"
					return result;
#line 2609 "chess-state.c"
				}
#line 382 "../lib/chess-state.vala"
				_tmp71_ = self->check_state;
#line 382 "../lib/chess-state.vala"
				if (_tmp71_ == CHECK_STATE_CHECK) {
#line 383 "../lib/chess-state.vala"
					result = FALSE;
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 383 "../lib/chess-state.vala"
					return result;
#line 2625 "chess-state.c"
				}
#line 386 "../lib/chess-state.vala"
				_tmp72_ = rook_end;
#line 386 "../lib/chess-state.vala"
				_tmp73_ = rook_end;
#line 386 "../lib/chess-state.vala"
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, _tmp72_), chess_state_get_file (self, _tmp73_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 387 "../lib/chess-state.vala"
					result = FALSE;
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 387 "../lib/chess-state.vala"
					return result;
#line 2643 "chess-state.c"
				}
#line 354 "../lib/chess-state.vala"
				_g_object_unref0 (rook);
#line 2647 "chess-state.c"
			}
#line 389 "../lib/chess-state.vala"
			break;
#line 2651 "chess-state.c"
		}
		default:
		{
#line 391 "../lib/chess-state.vala"
			break;
#line 2657 "chess-state.c"
		}
	}
#line 394 "../lib/chess-state.vala"
	if (!apply) {
#line 394 "../lib/chess-state.vala"
		_tmp74_ = !test_check;
#line 2664 "chess-state.c"
	} else {
#line 394 "../lib/chess-state.vala"
		_tmp74_ = FALSE;
#line 2668 "chess-state.c"
	}
#line 394 "../lib/chess-state.vala"
	if (_tmp74_) {
#line 395 "../lib/chess-state.vala"
		result = TRUE;
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 395 "../lib/chess-state.vala"
		return result;
#line 2680 "chess-state.c"
	}
#line 398 "../lib/chess-state.vala"
	if (apply) {
#line 2684 "chess-state.c"
		{
			gint i = 0;
#line 400 "../lib/chess-state.vala"
			i = 0;
#line 2689 "chess-state.c"
			{
				gboolean _tmp75_ = FALSE;
#line 400 "../lib/chess-state.vala"
				_tmp75_ = TRUE;
#line 400 "../lib/chess-state.vala"
				while (TRUE) {
#line 2696 "chess-state.c"
					gint _tmp77_;
					gint _tmp78_;
					gint _tmp79_;
					ChessPiece* p = NULL;
					gint _tmp80_;
					ChessPiece* _tmp81_;
					ChessPiece* _tmp82_;
					gboolean _tmp83_ = FALSE;
					gboolean _tmp84_ = FALSE;
					ChessPiece* _tmp85_;
					gint r = 0;
					gint _tmp92_;
					gint f = 0;
					gint _tmp93_;
					gint _tmp94_;
					gint _tmp95_;
#line 400 "../lib/chess-state.vala"
					if (!_tmp75_) {
#line 2715 "chess-state.c"
						gint _tmp76_;
#line 400 "../lib/chess-state.vala"
						_tmp76_ = i;
#line 400 "../lib/chess-state.vala"
						i = _tmp76_ + 1;
#line 2721 "chess-state.c"
					}
#line 400 "../lib/chess-state.vala"
					_tmp75_ = FALSE;
#line 400 "../lib/chess-state.vala"
					_tmp77_ = i;
#line 400 "../lib/chess-state.vala"
					if (!(_tmp77_ < 64)) {
#line 400 "../lib/chess-state.vala"
						break;
#line 2731 "chess-state.c"
					}
#line 403 "../lib/chess-state.vala"
					_tmp78_ = i;
#line 403 "../lib/chess-state.vala"
					_tmp79_ = start;
#line 403 "../lib/chess-state.vala"
					if (_tmp78_ == _tmp79_) {
#line 404 "../lib/chess-state.vala"
						continue;
#line 2741 "chess-state.c"
					}
#line 407 "../lib/chess-state.vala"
					_tmp80_ = i;
#line 407 "../lib/chess-state.vala"
					_tmp81_ = self->board[_tmp80_];
#line 407 "../lib/chess-state.vala"
					_tmp82_ = _g_object_ref0 (_tmp81_);
#line 407 "../lib/chess-state.vala"
					p = _tmp82_;
#line 408 "../lib/chess-state.vala"
					_tmp85_ = p;
#line 408 "../lib/chess-state.vala"
					if (_tmp85_ == NULL) {
#line 408 "../lib/chess-state.vala"
						_tmp84_ = TRUE;
#line 2757 "chess-state.c"
					} else {
						ChessPiece* _tmp86_;
						ChessPlayer* _tmp87_;
#line 408 "../lib/chess-state.vala"
						_tmp86_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp87_ = _tmp86_->player;
#line 408 "../lib/chess-state.vala"
						_tmp84_ = _tmp87_ != player;
#line 2767 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp84_) {
#line 408 "../lib/chess-state.vala"
						_tmp83_ = TRUE;
#line 2773 "chess-state.c"
					} else {
						ChessPiece* _tmp88_;
						PieceType _tmp89_;
						ChessPiece* _tmp90_;
						PieceType _tmp91_;
#line 408 "../lib/chess-state.vala"
						_tmp88_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp89_ = _tmp88_->type;
#line 408 "../lib/chess-state.vala"
						_tmp90_ = piece;
#line 408 "../lib/chess-state.vala"
						_tmp91_ = _tmp90_->type;
#line 408 "../lib/chess-state.vala"
						_tmp83_ = _tmp89_ != _tmp91_;
#line 2789 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp83_) {
#line 409 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 409 "../lib/chess-state.vala"
						continue;
#line 2797 "chess-state.c"
					}
#line 412 "../lib/chess-state.vala"
					_tmp92_ = i;
#line 412 "../lib/chess-state.vala"
					r = chess_state_get_rank (self, _tmp92_);
#line 413 "../lib/chess-state.vala"
					_tmp93_ = i;
#line 413 "../lib/chess-state.vala"
					f = chess_state_get_file (self, _tmp93_);
#line 414 "../lib/chess-state.vala"
					_tmp94_ = r;
#line 414 "../lib/chess-state.vala"
					_tmp95_ = f;
#line 414 "../lib/chess-state.vala"
					if (chess_state_move_with_coords (self, player, _tmp94_, _tmp95_, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 2813 "chess-state.c"
						gint _tmp96_;
						gint _tmp97_;
#line 416 "../lib/chess-state.vala"
						_tmp96_ = r;
#line 416 "../lib/chess-state.vala"
						if (_tmp96_ != r0) {
#line 417 "../lib/chess-state.vala"
							ambiguous_rank = TRUE;
#line 2822 "chess-state.c"
						}
#line 418 "../lib/chess-state.vala"
						_tmp97_ = f;
#line 418 "../lib/chess-state.vala"
						if (_tmp97_ != f0) {
#line 419 "../lib/chess-state.vala"
							ambiguous_file = TRUE;
#line 2830 "chess-state.c"
						}
					}
#line 400 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 2835 "chess-state.c"
				}
			}
		}
	}
#line 424 "../lib/chess-state.vala"
	_tmp98_ = self->priv->piece_masks[COLOR_WHITE];
#line 424 "../lib/chess-state.vala"
	old_white_mask = _tmp98_;
#line 425 "../lib/chess-state.vala"
	_tmp99_ = self->priv->piece_masks[COLOR_BLACK];
#line 425 "../lib/chess-state.vala"
	old_black_mask = _tmp99_;
#line 426 "../lib/chess-state.vala"
	_tmp100_ = self->can_castle_kingside[COLOR_WHITE];
#line 426 "../lib/chess-state.vala"
	old_white_can_castle_kingside = _tmp100_;
#line 427 "../lib/chess-state.vala"
	_tmp101_ = self->can_castle_queenside[COLOR_WHITE];
#line 427 "../lib/chess-state.vala"
	old_white_can_castle_queenside = _tmp101_;
#line 428 "../lib/chess-state.vala"
	_tmp102_ = self->can_castle_kingside[COLOR_BLACK];
#line 428 "../lib/chess-state.vala"
	old_black_can_castle_kingside = _tmp102_;
#line 429 "../lib/chess-state.vala"
	_tmp103_ = self->can_castle_queenside[COLOR_BLACK];
#line 429 "../lib/chess-state.vala"
	old_black_can_castle_queenside = _tmp103_;
#line 430 "../lib/chess-state.vala"
	_tmp104_ = self->en_passant_index;
#line 430 "../lib/chess-state.vala"
	old_en_passant_index = _tmp104_;
#line 431 "../lib/chess-state.vala"
	_tmp105_ = self->halfmove_clock;
#line 431 "../lib/chess-state.vala"
	old_halfmove_clock = _tmp105_;
#line 434 "../lib/chess-state.vala"
	_tmp106_ = start;
#line 434 "../lib/chess-state.vala"
	_g_object_unref0 (self->board[_tmp106_]);
#line 434 "../lib/chess-state.vala"
	self->board[_tmp106_] = NULL;
#line 434 "../lib/chess-state.vala"
	_tmp107_ = self->board[_tmp106_];
#line 435 "../lib/chess-state.vala"
	_tmp108_ = start;
#line 435 "../lib/chess-state.vala"
	_tmp109_ = BIT_BOARD_clear_location_masks[_tmp108_];
#line 435 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_WHITE] &= _tmp109_;
#line 435 "../lib/chess-state.vala"
	_tmp110_ = self->priv->piece_masks[COLOR_WHITE];
#line 436 "../lib/chess-state.vala"
	_tmp111_ = start;
#line 436 "../lib/chess-state.vala"
	_tmp112_ = BIT_BOARD_clear_location_masks[_tmp111_];
#line 436 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_BLACK] &= _tmp112_;
#line 436 "../lib/chess-state.vala"
	_tmp113_ = self->priv->piece_masks[COLOR_BLACK];
#line 437 "../lib/chess-state.vala"
	_tmp114_ = victim;
#line 437 "../lib/chess-state.vala"
	if (_tmp114_ != NULL) {
#line 2900 "chess-state.c"
		gint _tmp115_;
		ChessPiece* _tmp116_;
		gint _tmp117_;
		gint64 _tmp118_;
		gint64 _tmp119_;
		gint _tmp120_;
		gint64 _tmp121_;
		gint64 _tmp122_;
#line 439 "../lib/chess-state.vala"
		_tmp115_ = victim_index;
#line 439 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp115_]);
#line 439 "../lib/chess-state.vala"
		self->board[_tmp115_] = NULL;
#line 439 "../lib/chess-state.vala"
		_tmp116_ = self->board[_tmp115_];
#line 440 "../lib/chess-state.vala"
		_tmp117_ = victim_index;
#line 440 "../lib/chess-state.vala"
		_tmp118_ = BIT_BOARD_clear_location_masks[_tmp117_];
#line 440 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] &= _tmp118_;
#line 440 "../lib/chess-state.vala"
		_tmp119_ = self->priv->piece_masks[COLOR_WHITE];
#line 441 "../lib/chess-state.vala"
		_tmp120_ = victim_index;
#line 441 "../lib/chess-state.vala"
		_tmp121_ = BIT_BOARD_clear_location_masks[_tmp120_];
#line 441 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] &= _tmp121_;
#line 441 "../lib/chess-state.vala"
		_tmp122_ = self->priv->piece_masks[COLOR_BLACK];
#line 2933 "chess-state.c"
	}
#line 443 "../lib/chess-state.vala"
	_tmp123_ = is_promotion;
#line 443 "../lib/chess-state.vala"
	if (_tmp123_) {
#line 2939 "chess-state.c"
		gint _tmp124_;
		ChessPiece* _tmp125_;
		ChessPiece* _tmp126_;
#line 444 "../lib/chess-state.vala"
		_tmp124_ = end;
#line 444 "../lib/chess-state.vala"
		_tmp125_ = chess_piece_new (player, promotion_type);
#line 444 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp124_]);
#line 444 "../lib/chess-state.vala"
		self->board[_tmp124_] = _tmp125_;
#line 444 "../lib/chess-state.vala"
		_tmp126_ = self->board[_tmp124_];
#line 2953 "chess-state.c"
	} else {
		gint _tmp127_;
		ChessPiece* _tmp128_;
		ChessPiece* _tmp129_;
		ChessPiece* _tmp130_;
#line 446 "../lib/chess-state.vala"
		_tmp127_ = end;
#line 446 "../lib/chess-state.vala"
		_tmp128_ = piece;
#line 446 "../lib/chess-state.vala"
		_tmp129_ = _g_object_ref0 (_tmp128_);
#line 446 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp127_]);
#line 446 "../lib/chess-state.vala"
		self->board[_tmp127_] = _tmp129_;
#line 446 "../lib/chess-state.vala"
		_tmp130_ = self->board[_tmp127_];
#line 2971 "chess-state.c"
	}
#line 447 "../lib/chess-state.vala"
	_tmp131_ = color;
#line 447 "../lib/chess-state.vala"
	_tmp132_ = end_mask;
#line 447 "../lib/chess-state.vala"
	self->priv->piece_masks[_tmp131_] |= _tmp132_;
#line 447 "../lib/chess-state.vala"
	_tmp133_ = self->priv->piece_masks[_tmp131_];
#line 448 "../lib/chess-state.vala"
	_tmp134_ = opponent_color;
#line 448 "../lib/chess-state.vala"
	_tmp135_ = end;
#line 448 "../lib/chess-state.vala"
	_tmp136_ = BIT_BOARD_clear_location_masks[_tmp135_];
#line 448 "../lib/chess-state.vala"
	self->priv->piece_masks[_tmp134_] &= _tmp136_;
#line 448 "../lib/chess-state.vala"
	_tmp137_ = self->priv->piece_masks[_tmp134_];
#line 449 "../lib/chess-state.vala"
	_tmp138_ = rook_start;
#line 449 "../lib/chess-state.vala"
	if (_tmp138_ >= 0) {
#line 2995 "chess-state.c"
		ChessPiece* rook = NULL;
		gint _tmp139_;
		ChessPiece* _tmp140_;
		ChessPiece* _tmp141_;
		gint _tmp142_;
		ChessPiece* _tmp143_;
		Color _tmp144_;
		gint _tmp145_;
		gint64 _tmp146_;
		gint64 _tmp147_;
		gint _tmp148_;
		ChessPiece* _tmp149_;
		ChessPiece* _tmp150_;
		ChessPiece* _tmp151_;
		Color _tmp152_;
		gint _tmp153_;
		gint64 _tmp154_;
		gint64 _tmp155_;
#line 451 "../lib/chess-state.vala"
		_tmp139_ = rook_start;
#line 451 "../lib/chess-state.vala"
		_tmp140_ = self->board[_tmp139_];
#line 451 "../lib/chess-state.vala"
		_tmp141_ = _g_object_ref0 (_tmp140_);
#line 451 "../lib/chess-state.vala"
		rook = _tmp141_;
#line 452 "../lib/chess-state.vala"
		_tmp142_ = rook_start;
#line 452 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp142_]);
#line 452 "../lib/chess-state.vala"
		self->board[_tmp142_] = NULL;
#line 452 "../lib/chess-state.vala"
		_tmp143_ = self->board[_tmp142_];
#line 453 "../lib/chess-state.vala"
		_tmp144_ = color;
#line 453 "../lib/chess-state.vala"
		_tmp145_ = rook_start;
#line 453 "../lib/chess-state.vala"
		_tmp146_ = BIT_BOARD_clear_location_masks[_tmp145_];
#line 453 "../lib/chess-state.vala"
		self->priv->piece_masks[_tmp144_] &= _tmp146_;
#line 453 "../lib/chess-state.vala"
		_tmp147_ = self->priv->piece_masks[_tmp144_];
#line 454 "../lib/chess-state.vala"
		_tmp148_ = rook_end;
#line 454 "../lib/chess-state.vala"
		_tmp149_ = rook;
#line 454 "../lib/chess-state.vala"
		_tmp150_ = _g_object_ref0 (_tmp149_);
#line 454 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp148_]);
#line 454 "../lib/chess-state.vala"
		self->board[_tmp148_] = _tmp150_;
#line 454 "../lib/chess-state.vala"
		_tmp151_ = self->board[_tmp148_];
#line 455 "../lib/chess-state.vala"
		_tmp152_ = color;
#line 455 "../lib/chess-state.vala"
		_tmp153_ = rook_end;
#line 455 "../lib/chess-state.vala"
		_tmp154_ = BIT_BOARD_set_location_masks[_tmp153_];
#line 455 "../lib/chess-state.vala"
		self->priv->piece_masks[_tmp152_] |= _tmp154_;
#line 455 "../lib/chess-state.vala"
		_tmp155_ = self->priv->piece_masks[_tmp152_];
#line 449 "../lib/chess-state.vala"
		_g_object_unref0 (rook);
#line 3064 "chess-state.c"
	}
#line 459 "../lib/chess-state.vala"
	_tmp156_ = piece;
#line 459 "../lib/chess-state.vala"
	_tmp157_ = _tmp156_->type;
#line 459 "../lib/chess-state.vala"
	if (_tmp157_ == PIECE_TYPE_KING) {
#line 3072 "chess-state.c"
		Color _tmp158_;
		gboolean _tmp159_;
		Color _tmp160_;
		gboolean _tmp161_;
#line 461 "../lib/chess-state.vala"
		_tmp158_ = color;
#line 461 "../lib/chess-state.vala"
		self->can_castle_kingside[_tmp158_] = FALSE;
#line 461 "../lib/chess-state.vala"
		_tmp159_ = self->can_castle_kingside[_tmp158_];
#line 462 "../lib/chess-state.vala"
		_tmp160_ = color;
#line 462 "../lib/chess-state.vala"
		self->can_castle_queenside[_tmp160_] = FALSE;
#line 462 "../lib/chess-state.vala"
		_tmp161_ = self->can_castle_queenside[_tmp160_];
#line 3089 "chess-state.c"
	} else {
		ChessPiece* _tmp162_;
		PieceType _tmp163_;
#line 465 "../lib/chess-state.vala"
		_tmp162_ = piece;
#line 465 "../lib/chess-state.vala"
		_tmp163_ = _tmp162_->type;
#line 465 "../lib/chess-state.vala"
		if (_tmp163_ == PIECE_TYPE_ROOK) {
#line 3099 "chess-state.c"
			gint _tmp164_ = 0;
			Color _tmp165_;
			gint base_rank = 0;
			gint _tmp166_;
#line 467 "../lib/chess-state.vala"
			_tmp165_ = color;
#line 467 "../lib/chess-state.vala"
			if (_tmp165_ == COLOR_WHITE) {
#line 467 "../lib/chess-state.vala"
				_tmp164_ = 0;
#line 3110 "chess-state.c"
			} else {
#line 467 "../lib/chess-state.vala"
				_tmp164_ = 7;
#line 3114 "chess-state.c"
			}
#line 467 "../lib/chess-state.vala"
			base_rank = _tmp164_;
#line 468 "../lib/chess-state.vala"
			_tmp166_ = base_rank;
#line 468 "../lib/chess-state.vala"
			if (r0 == _tmp166_) {
#line 470 "../lib/chess-state.vala"
				if (f0 == 0) {
#line 3124 "chess-state.c"
					Color _tmp167_;
					gboolean _tmp168_;
#line 471 "../lib/chess-state.vala"
					_tmp167_ = color;
#line 471 "../lib/chess-state.vala"
					self->can_castle_queenside[_tmp167_] = FALSE;
#line 471 "../lib/chess-state.vala"
					_tmp168_ = self->can_castle_queenside[_tmp167_];
#line 3133 "chess-state.c"
				} else {
#line 472 "../lib/chess-state.vala"
					if (f0 == 7) {
#line 3137 "chess-state.c"
						Color _tmp169_;
						gboolean _tmp170_;
#line 473 "../lib/chess-state.vala"
						_tmp169_ = color;
#line 473 "../lib/chess-state.vala"
						self->can_castle_kingside[_tmp169_] = FALSE;
#line 473 "../lib/chess-state.vala"
						_tmp170_ = self->can_castle_kingside[_tmp169_];
#line 3146 "chess-state.c"
					}
				}
			}
		} else {
			gboolean _tmp171_ = FALSE;
			ChessPiece* _tmp172_;
#line 477 "../lib/chess-state.vala"
			_tmp172_ = victim;
#line 477 "../lib/chess-state.vala"
			if (_tmp172_ != NULL) {
#line 3157 "chess-state.c"
				ChessPiece* _tmp173_;
				PieceType _tmp174_;
#line 477 "../lib/chess-state.vala"
				_tmp173_ = victim;
#line 477 "../lib/chess-state.vala"
				_tmp174_ = _tmp173_->type;
#line 477 "../lib/chess-state.vala"
				_tmp171_ = _tmp174_ == PIECE_TYPE_ROOK;
#line 3166 "chess-state.c"
			} else {
#line 477 "../lib/chess-state.vala"
				_tmp171_ = FALSE;
#line 3170 "chess-state.c"
			}
#line 477 "../lib/chess-state.vala"
			if (_tmp171_) {
#line 3174 "chess-state.c"
				gint _tmp175_ = 0;
				Color _tmp176_;
				gint base_rank = 0;
				gint _tmp177_;
#line 479 "../lib/chess-state.vala"
				_tmp176_ = opponent_color;
#line 479 "../lib/chess-state.vala"
				if (_tmp176_ == COLOR_WHITE) {
#line 479 "../lib/chess-state.vala"
					_tmp175_ = 0;
#line 3185 "chess-state.c"
				} else {
#line 479 "../lib/chess-state.vala"
					_tmp175_ = 7;
#line 3189 "chess-state.c"
				}
#line 479 "../lib/chess-state.vala"
				base_rank = _tmp175_;
#line 480 "../lib/chess-state.vala"
				_tmp177_ = base_rank;
#line 480 "../lib/chess-state.vala"
				if (r1 == _tmp177_) {
#line 482 "../lib/chess-state.vala"
					if (f1 == 0) {
#line 3199 "chess-state.c"
						Color _tmp178_;
						gboolean _tmp179_;
#line 483 "../lib/chess-state.vala"
						_tmp178_ = opponent_color;
#line 483 "../lib/chess-state.vala"
						self->can_castle_queenside[_tmp178_] = FALSE;
#line 483 "../lib/chess-state.vala"
						_tmp179_ = self->can_castle_queenside[_tmp178_];
#line 3208 "chess-state.c"
					} else {
#line 484 "../lib/chess-state.vala"
						if (f1 == 7) {
#line 3212 "chess-state.c"
							Color _tmp180_;
							gboolean _tmp181_;
#line 485 "../lib/chess-state.vala"
							_tmp180_ = opponent_color;
#line 485 "../lib/chess-state.vala"
							self->can_castle_kingside[_tmp180_] = FALSE;
#line 485 "../lib/chess-state.vala"
							_tmp181_ = self->can_castle_kingside[_tmp180_];
#line 3221 "chess-state.c"
						}
					}
				}
			}
		}
	}
#line 490 "../lib/chess-state.vala"
	_tmp183_ = piece;
#line 490 "../lib/chess-state.vala"
	_tmp184_ = _tmp183_->type;
#line 490 "../lib/chess-state.vala"
	if (_tmp184_ == PIECE_TYPE_PAWN) {
#line 3234 "chess-state.c"
		gint64 _tmp185_;
#line 490 "../lib/chess-state.vala"
		_tmp185_ = over_mask;
#line 490 "../lib/chess-state.vala"
		_tmp182_ = _tmp185_ != ((gint64) 0);
#line 3240 "chess-state.c"
	} else {
#line 490 "../lib/chess-state.vala"
		_tmp182_ = FALSE;
#line 3244 "chess-state.c"
	}
#line 490 "../lib/chess-state.vala"
	if (_tmp182_) {
#line 491 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
#line 3250 "chess-state.c"
	} else {
#line 493 "../lib/chess-state.vala"
		self->en_passant_index = -1;
#line 3254 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	_tmp187_ = piece;
#line 496 "../lib/chess-state.vala"
	_tmp188_ = _tmp187_->type;
#line 496 "../lib/chess-state.vala"
	if (_tmp188_ == PIECE_TYPE_PAWN) {
#line 496 "../lib/chess-state.vala"
		_tmp186_ = TRUE;
#line 3264 "chess-state.c"
	} else {
		ChessPiece* _tmp189_;
#line 496 "../lib/chess-state.vala"
		_tmp189_ = victim;
#line 496 "../lib/chess-state.vala"
		_tmp186_ = _tmp189_ != NULL;
#line 3271 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	if (_tmp186_) {
#line 497 "../lib/chess-state.vala"
		self->halfmove_clock = 0;
#line 3277 "chess-state.c"
	} else {
		gint _tmp190_;
#line 499 "../lib/chess-state.vala"
		_tmp190_ = self->halfmove_clock;
#line 499 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp190_ + 1;
#line 3284 "chess-state.c"
	}
#line 502 "../lib/chess-state.vala"
	_result_ = TRUE;
#line 503 "../lib/chess-state.vala"
	if (test_check) {
#line 503 "../lib/chess-state.vala"
		_tmp191_ = chess_state_is_in_check (self, player);
#line 3292 "chess-state.c"
	} else {
#line 503 "../lib/chess-state.vala"
		_tmp191_ = FALSE;
#line 3296 "chess-state.c"
	}
#line 503 "../lib/chess-state.vala"
	if (_tmp191_) {
#line 504 "../lib/chess-state.vala"
		_result_ = FALSE;
#line 3302 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (!apply) {
#line 507 "../lib/chess-state.vala"
		_tmp192_ = TRUE;
#line 3308 "chess-state.c"
	} else {
		gboolean _tmp193_;
#line 507 "../lib/chess-state.vala"
		_tmp193_ = _result_;
#line 507 "../lib/chess-state.vala"
		_tmp192_ = !_tmp193_;
#line 3315 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (_tmp192_) {
#line 3319 "chess-state.c"
		gint _tmp194_;
		ChessPiece* _tmp195_;
		ChessPiece* _tmp196_;
		ChessPiece* _tmp197_;
		gint _tmp198_;
		ChessPiece* _tmp199_;
		ChessPiece* _tmp200_;
		gint _tmp205_;
		gint64 _tmp215_;
		gint64 _tmp216_;
		gint64 _tmp217_;
		gint64 _tmp218_;
		gboolean _tmp219_;
		gboolean _tmp220_;
		gboolean _tmp221_;
		gboolean _tmp222_;
		gboolean _tmp223_;
		gboolean _tmp224_;
		gboolean _tmp225_;
		gboolean _tmp226_;
		gint _tmp227_;
		gint _tmp228_;
#line 509 "../lib/chess-state.vala"
		_tmp194_ = start;
#line 509 "../lib/chess-state.vala"
		_tmp195_ = piece;
#line 509 "../lib/chess-state.vala"
		_tmp196_ = _g_object_ref0 (_tmp195_);
#line 509 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp194_]);
#line 509 "../lib/chess-state.vala"
		self->board[_tmp194_] = _tmp196_;
#line 509 "../lib/chess-state.vala"
		_tmp197_ = self->board[_tmp194_];
#line 510 "../lib/chess-state.vala"
		_tmp198_ = end;
#line 510 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp198_]);
#line 510 "../lib/chess-state.vala"
		self->board[_tmp198_] = NULL;
#line 510 "../lib/chess-state.vala"
		_tmp199_ = self->board[_tmp198_];
#line 511 "../lib/chess-state.vala"
		_tmp200_ = victim;
#line 511 "../lib/chess-state.vala"
		if (_tmp200_ != NULL) {
#line 3366 "chess-state.c"
			gint _tmp201_;
			ChessPiece* _tmp202_;
			ChessPiece* _tmp203_;
			ChessPiece* _tmp204_;
#line 512 "../lib/chess-state.vala"
			_tmp201_ = victim_index;
#line 512 "../lib/chess-state.vala"
			_tmp202_ = victim;
#line 512 "../lib/chess-state.vala"
			_tmp203_ = _g_object_ref0 (_tmp202_);
#line 512 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[_tmp201_]);
#line 512 "../lib/chess-state.vala"
			self->board[_tmp201_] = _tmp203_;
#line 512 "../lib/chess-state.vala"
			_tmp204_ = self->board[_tmp201_];
#line 3383 "chess-state.c"
		}
#line 513 "../lib/chess-state.vala"
		_tmp205_ = rook_start;
#line 513 "../lib/chess-state.vala"
		if (_tmp205_ >= 0) {
#line 3389 "chess-state.c"
			ChessPiece* rook = NULL;
			gint _tmp206_;
			ChessPiece* _tmp207_;
			ChessPiece* _tmp208_;
			gint _tmp209_;
			ChessPiece* _tmp210_;
			ChessPiece* _tmp211_;
			ChessPiece* _tmp212_;
			gint _tmp213_;
			ChessPiece* _tmp214_;
#line 515 "../lib/chess-state.vala"
			_tmp206_ = rook_end;
#line 515 "../lib/chess-state.vala"
			_tmp207_ = self->board[_tmp206_];
#line 515 "../lib/chess-state.vala"
			_tmp208_ = _g_object_ref0 (_tmp207_);
#line 515 "../lib/chess-state.vala"
			rook = _tmp208_;
#line 516 "../lib/chess-state.vala"
			_tmp209_ = rook_start;
#line 516 "../lib/chess-state.vala"
			_tmp210_ = rook;
#line 516 "../lib/chess-state.vala"
			_tmp211_ = _g_object_ref0 (_tmp210_);
#line 516 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[_tmp209_]);
#line 516 "../lib/chess-state.vala"
			self->board[_tmp209_] = _tmp211_;
#line 516 "../lib/chess-state.vala"
			_tmp212_ = self->board[_tmp209_];
#line 517 "../lib/chess-state.vala"
			_tmp213_ = rook_end;
#line 517 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[_tmp213_]);
#line 517 "../lib/chess-state.vala"
			self->board[_tmp213_] = NULL;
#line 517 "../lib/chess-state.vala"
			_tmp214_ = self->board[_tmp213_];
#line 513 "../lib/chess-state.vala"
			_g_object_unref0 (rook);
#line 3430 "chess-state.c"
		}
#line 519 "../lib/chess-state.vala"
		_tmp215_ = old_white_mask;
#line 519 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] = _tmp215_;
#line 519 "../lib/chess-state.vala"
		_tmp216_ = self->priv->piece_masks[COLOR_WHITE];
#line 520 "../lib/chess-state.vala"
		_tmp217_ = old_black_mask;
#line 520 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] = _tmp217_;
#line 520 "../lib/chess-state.vala"
		_tmp218_ = self->priv->piece_masks[COLOR_BLACK];
#line 521 "../lib/chess-state.vala"
		_tmp219_ = old_white_can_castle_kingside;
#line 521 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_WHITE] = _tmp219_;
#line 521 "../lib/chess-state.vala"
		_tmp220_ = self->can_castle_kingside[COLOR_WHITE];
#line 522 "../lib/chess-state.vala"
		_tmp221_ = old_white_can_castle_queenside;
#line 522 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_WHITE] = _tmp221_;
#line 522 "../lib/chess-state.vala"
		_tmp222_ = self->can_castle_queenside[COLOR_WHITE];
#line 523 "../lib/chess-state.vala"
		_tmp223_ = old_black_can_castle_kingside;
#line 523 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_BLACK] = _tmp223_;
#line 523 "../lib/chess-state.vala"
		_tmp224_ = self->can_castle_kingside[COLOR_BLACK];
#line 524 "../lib/chess-state.vala"
		_tmp225_ = old_black_can_castle_queenside;
#line 524 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_BLACK] = _tmp225_;
#line 524 "../lib/chess-state.vala"
		_tmp226_ = self->can_castle_queenside[COLOR_BLACK];
#line 525 "../lib/chess-state.vala"
		_tmp227_ = old_en_passant_index;
#line 525 "../lib/chess-state.vala"
		self->en_passant_index = _tmp227_;
#line 526 "../lib/chess-state.vala"
		_tmp228_ = old_halfmove_clock;
#line 526 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp228_;
#line 528 "../lib/chess-state.vala"
		result = _result_;
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 528 "../lib/chess-state.vala"
		return result;
#line 3484 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp230_ = color;
#line 531 "../lib/chess-state.vala"
	if (_tmp230_ == COLOR_WHITE) {
#line 3490 "chess-state.c"
		ChessPlayer* _tmp231_;
#line 531 "../lib/chess-state.vala"
		_tmp231_ = self->players[COLOR_BLACK];
#line 531 "../lib/chess-state.vala"
		_tmp229_ = _tmp231_;
#line 3496 "chess-state.c"
	} else {
		ChessPlayer* _tmp232_;
#line 531 "../lib/chess-state.vala"
		_tmp232_ = self->players[COLOR_WHITE];
#line 531 "../lib/chess-state.vala"
		_tmp229_ = _tmp232_;
#line 3503 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp233_ = _g_object_ref0 (_tmp229_);
#line 531 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 531 "../lib/chess-state.vala"
	self->current_player = _tmp233_;
#line 532 "../lib/chess-state.vala"
	_tmp234_ = self->current_player;
#line 532 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp234_);
#line 534 "../lib/chess-state.vala"
	_tmp235_ = chess_move_new ();
#line 534 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 534 "../lib/chess-state.vala"
	self->last_move = _tmp235_;
#line 535 "../lib/chess-state.vala"
	_tmp236_ = self->last_move;
#line 535 "../lib/chess-state.vala"
	_tmp237_ = self->number;
#line 535 "../lib/chess-state.vala"
	_tmp236_->number = _tmp237_;
#line 536 "../lib/chess-state.vala"
	_tmp238_ = self->last_move;
#line 536 "../lib/chess-state.vala"
	_tmp239_ = piece;
#line 536 "../lib/chess-state.vala"
	_tmp240_ = _g_object_ref0 (_tmp239_);
#line 536 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp238_->piece);
#line 536 "../lib/chess-state.vala"
	_tmp238_->piece = _tmp240_;
#line 537 "../lib/chess-state.vala"
	_tmp241_ = is_promotion;
#line 537 "../lib/chess-state.vala"
	if (_tmp241_) {
#line 3541 "chess-state.c"
		ChessMove* _tmp242_;
		gint _tmp243_;
		ChessPiece* _tmp244_;
		ChessPiece* _tmp245_;
#line 538 "../lib/chess-state.vala"
		_tmp242_ = self->last_move;
#line 538 "../lib/chess-state.vala"
		_tmp243_ = end;
#line 538 "../lib/chess-state.vala"
		_tmp244_ = self->board[_tmp243_];
#line 538 "../lib/chess-state.vala"
		_tmp245_ = _g_object_ref0 (_tmp244_);
#line 538 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp242_->promotion_piece);
#line 538 "../lib/chess-state.vala"
		_tmp242_->promotion_piece = _tmp245_;
#line 3558 "chess-state.c"
	}
#line 539 "../lib/chess-state.vala"
	_tmp246_ = self->last_move;
#line 539 "../lib/chess-state.vala"
	_tmp247_ = victim;
#line 539 "../lib/chess-state.vala"
	_tmp248_ = _g_object_ref0 (_tmp247_);
#line 539 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp246_->victim);
#line 539 "../lib/chess-state.vala"
	_tmp246_->victim = _tmp248_;
#line 540 "../lib/chess-state.vala"
	_tmp249_ = rook_end;
#line 540 "../lib/chess-state.vala"
	if (_tmp249_ >= 0) {
#line 3574 "chess-state.c"
		ChessMove* _tmp250_;
		gint _tmp251_;
		ChessPiece* _tmp252_;
		ChessPiece* _tmp253_;
#line 541 "../lib/chess-state.vala"
		_tmp250_ = self->last_move;
#line 541 "../lib/chess-state.vala"
		_tmp251_ = rook_end;
#line 541 "../lib/chess-state.vala"
		_tmp252_ = self->board[_tmp251_];
#line 541 "../lib/chess-state.vala"
		_tmp253_ = _g_object_ref0 (_tmp252_);
#line 541 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp250_->castling_rook);
#line 541 "../lib/chess-state.vala"
		_tmp250_->castling_rook = _tmp253_;
#line 3591 "chess-state.c"
	}
#line 542 "../lib/chess-state.vala"
	_tmp254_ = self->last_move;
#line 542 "../lib/chess-state.vala"
	_tmp254_->r0 = r0;
#line 543 "../lib/chess-state.vala"
	_tmp255_ = self->last_move;
#line 543 "../lib/chess-state.vala"
	_tmp255_->f0 = f0;
#line 544 "../lib/chess-state.vala"
	_tmp256_ = self->last_move;
#line 544 "../lib/chess-state.vala"
	_tmp256_->r1 = r1;
#line 545 "../lib/chess-state.vala"
	_tmp257_ = self->last_move;
#line 545 "../lib/chess-state.vala"
	_tmp257_->f1 = f1;
#line 546 "../lib/chess-state.vala"
	_tmp258_ = self->last_move;
#line 546 "../lib/chess-state.vala"
	_tmp259_ = ambiguous_rank;
#line 546 "../lib/chess-state.vala"
	_tmp258_->ambiguous_rank = _tmp259_;
#line 547 "../lib/chess-state.vala"
	_tmp260_ = self->last_move;
#line 547 "../lib/chess-state.vala"
	_tmp261_ = ambiguous_file;
#line 547 "../lib/chess-state.vala"
	_tmp260_->ambiguous_file = _tmp261_;
#line 548 "../lib/chess-state.vala"
	_tmp262_ = self->last_move;
#line 548 "../lib/chess-state.vala"
	_tmp263_ = en_passant;
#line 548 "../lib/chess-state.vala"
	_tmp262_->en_passant = _tmp263_;
#line 549 "../lib/chess-state.vala"
	_tmp264_ = self->last_move;
#line 549 "../lib/chess-state.vala"
	_tmp265_ = self->check_state;
#line 549 "../lib/chess-state.vala"
	_tmp264_->check_state = _tmp265_;
#line 551 "../lib/chess-state.vala"
	result = TRUE;
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (victim);
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (piece);
#line 551 "../lib/chess-state.vala"
	return result;
#line 3641 "chess-state.c"
}


ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessResult result = 0;
	CheckState _tmp0_;
	ChessPlayer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ChessMove* _tmp6_;
#line 554 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 556 "../lib/chess-state.vala"
	_vala_rule = CHESS_RULE_CHECKMATE;
#line 557 "../lib/chess-state.vala"
	_tmp0_ = self->check_state;
#line 557 "../lib/chess-state.vala"
	if (_tmp0_ == CHECK_STATE_CHECKMATE) {
#line 3664 "chess-state.c"
		ChessPlayer* _tmp1_;
		Color _tmp2_;
#line 559 "../lib/chess-state.vala"
		_tmp1_ = self->current_player;
#line 559 "../lib/chess-state.vala"
		_tmp2_ = _tmp1_->color;
#line 559 "../lib/chess-state.vala"
		if (_tmp2_ == COLOR_WHITE) {
#line 561 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 562 "../lib/chess-state.vala"
			result = CHESS_RESULT_BLACK_WON;
#line 562 "../lib/chess-state.vala"
			if (rule) {
#line 562 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 3681 "chess-state.c"
			}
#line 562 "../lib/chess-state.vala"
			return result;
#line 3685 "chess-state.c"
		} else {
#line 566 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 567 "../lib/chess-state.vala"
			result = CHESS_RESULT_WHITE_WON;
#line 567 "../lib/chess-state.vala"
			if (rule) {
#line 567 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 3695 "chess-state.c"
			}
#line 567 "../lib/chess-state.vala"
			return result;
#line 3699 "chess-state.c"
		}
	}
#line 571 "../lib/chess-state.vala"
	_tmp3_ = self->current_player;
#line 571 "../lib/chess-state.vala"
	if (!chess_state_can_move (self, _tmp3_)) {
#line 573 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_STALEMATE;
#line 574 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 574 "../lib/chess-state.vala"
		if (rule) {
#line 574 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 3714 "chess-state.c"
		}
#line 574 "../lib/chess-state.vala"
		return result;
#line 3718 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	_tmp6_ = self->last_move;
#line 577 "../lib/chess-state.vala"
	if (_tmp6_ != NULL) {
#line 3724 "chess-state.c"
		ChessMove* _tmp7_;
		ChessPiece* _tmp8_;
#line 577 "../lib/chess-state.vala"
		_tmp7_ = self->last_move;
#line 577 "../lib/chess-state.vala"
		_tmp8_ = _tmp7_->victim;
#line 577 "../lib/chess-state.vala"
		_tmp5_ = _tmp8_ != NULL;
#line 3733 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp5_ = FALSE;
#line 3737 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 577 "../lib/chess-state.vala"
		_tmp4_ = !chess_state_have_sufficient_material (self);
#line 3743 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp4_ = FALSE;
#line 3747 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 579 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
#line 580 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 580 "../lib/chess-state.vala"
		if (rule) {
#line 580 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 3759 "chess-state.c"
		}
#line 580 "../lib/chess-state.vala"
		return result;
#line 3763 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	result = CHESS_RESULT_IN_PROGRESS;
#line 583 "../lib/chess-state.vala"
	if (rule) {
#line 583 "../lib/chess-state.vala"
		*rule = _vala_rule;
#line 3771 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	return result;
#line 3775 "chess-state.c"
}


static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result = 0;
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, 0);
#line 588 "../lib/chess-state.vala"
	if (chess_state_is_in_check (self, player)) {
#line 590 "../lib/chess-state.vala"
		if (chess_state_is_in_checkmate (self, player)) {
#line 591 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECKMATE;
#line 591 "../lib/chess-state.vala"
			return result;
#line 3796 "chess-state.c"
		} else {
#line 593 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECK;
#line 593 "../lib/chess-state.vala"
			return result;
#line 3802 "chess-state.c"
		}
	}
#line 595 "../lib/chess-state.vala"
	result = CHECK_STATE_NONE;
#line 595 "../lib/chess-state.vala"
	return result;
#line 3809 "chess-state.c"
}


gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	gboolean result = FALSE;
	ChessPlayer* _tmp0_ = NULL;
	Color _tmp1_;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp4_;
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 600 "../lib/chess-state.vala"
	_tmp1_ = player->color;
#line 600 "../lib/chess-state.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 3830 "chess-state.c"
		ChessPlayer* _tmp2_;
#line 600 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_BLACK];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 3836 "chess-state.c"
	} else {
		ChessPlayer* _tmp3_;
#line 600 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_WHITE];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 3843 "chess-state.c"
	}
#line 600 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 600 "../lib/chess-state.vala"
	opponent = _tmp4_;
#line 3849 "chess-state.c"
	{
		gint king_index = 0;
#line 603 "../lib/chess-state.vala"
		king_index = 0;
#line 3854 "chess-state.c"
		{
			gboolean _tmp5_ = FALSE;
#line 603 "../lib/chess-state.vala"
			_tmp5_ = TRUE;
#line 603 "../lib/chess-state.vala"
			while (TRUE) {
#line 3861 "chess-state.c"
				gint _tmp7_;
				ChessPiece* p = NULL;
				gint _tmp8_;
				ChessPiece* _tmp9_;
				ChessPiece* _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				ChessPiece* _tmp13_;
#line 603 "../lib/chess-state.vala"
				if (!_tmp5_) {
#line 3872 "chess-state.c"
					gint _tmp6_;
#line 603 "../lib/chess-state.vala"
					_tmp6_ = king_index;
#line 603 "../lib/chess-state.vala"
					king_index = _tmp6_ + 1;
#line 3878 "chess-state.c"
				}
#line 603 "../lib/chess-state.vala"
				_tmp5_ = FALSE;
#line 603 "../lib/chess-state.vala"
				_tmp7_ = king_index;
#line 603 "../lib/chess-state.vala"
				if (!(_tmp7_ < 64)) {
#line 603 "../lib/chess-state.vala"
					break;
#line 3888 "chess-state.c"
				}
#line 605 "../lib/chess-state.vala"
				_tmp8_ = king_index;
#line 605 "../lib/chess-state.vala"
				_tmp9_ = self->board[_tmp8_];
#line 605 "../lib/chess-state.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 605 "../lib/chess-state.vala"
				p = _tmp10_;
#line 606 "../lib/chess-state.vala"
				_tmp13_ = p;
#line 606 "../lib/chess-state.vala"
				if (_tmp13_ != NULL) {
#line 3902 "chess-state.c"
					ChessPiece* _tmp14_;
					ChessPlayer* _tmp15_;
#line 606 "../lib/chess-state.vala"
					_tmp14_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp15_ = _tmp14_->player;
#line 606 "../lib/chess-state.vala"
					_tmp12_ = _tmp15_ == player;
#line 3911 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp12_ = FALSE;
#line 3915 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp12_) {
#line 3919 "chess-state.c"
					ChessPiece* _tmp16_;
					PieceType _tmp17_;
#line 606 "../lib/chess-state.vala"
					_tmp16_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp17_ = _tmp16_->type;
#line 606 "../lib/chess-state.vala"
					_tmp11_ = _tmp17_ == PIECE_TYPE_KING;
#line 3928 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp11_ = FALSE;
#line 3932 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp11_) {
#line 3936 "chess-state.c"
					{
						gint start = 0;
#line 609 "../lib/chess-state.vala"
						start = 0;
#line 3941 "chess-state.c"
						{
							gboolean _tmp18_ = FALSE;
#line 609 "../lib/chess-state.vala"
							_tmp18_ = TRUE;
#line 609 "../lib/chess-state.vala"
							while (TRUE) {
#line 3948 "chess-state.c"
								gint _tmp20_;
								ChessPlayer* _tmp21_;
								gint _tmp22_;
								gint _tmp23_;
								gint _tmp24_;
								gint _tmp25_;
#line 609 "../lib/chess-state.vala"
								if (!_tmp18_) {
#line 3957 "chess-state.c"
									gint _tmp19_;
#line 609 "../lib/chess-state.vala"
									_tmp19_ = start;
#line 609 "../lib/chess-state.vala"
									start = _tmp19_ + 1;
#line 3963 "chess-state.c"
								}
#line 609 "../lib/chess-state.vala"
								_tmp18_ = FALSE;
#line 609 "../lib/chess-state.vala"
								_tmp20_ = start;
#line 609 "../lib/chess-state.vala"
								if (!(_tmp20_ < 64)) {
#line 609 "../lib/chess-state.vala"
									break;
#line 3973 "chess-state.c"
								}
#line 611 "../lib/chess-state.vala"
								_tmp21_ = opponent;
#line 611 "../lib/chess-state.vala"
								_tmp22_ = start;
#line 611 "../lib/chess-state.vala"
								_tmp23_ = start;
#line 611 "../lib/chess-state.vala"
								_tmp24_ = king_index;
#line 611 "../lib/chess-state.vala"
								_tmp25_ = king_index;
#line 611 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, _tmp21_, chess_state_get_rank (self, _tmp22_), chess_state_get_file (self, _tmp23_), chess_state_get_rank (self, _tmp24_), chess_state_get_file (self, _tmp25_), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
#line 615 "../lib/chess-state.vala"
									result = TRUE;
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (opponent);
#line 615 "../lib/chess-state.vala"
									return result;
#line 3995 "chess-state.c"
								}
							}
						}
					}
				}
#line 603 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4003 "chess-state.c"
			}
		}
	}
#line 620 "../lib/chess-state.vala"
	result = FALSE;
#line 620 "../lib/chess-state.vala"
	_g_object_unref0 (opponent);
#line 620 "../lib/chess-state.vala"
	return result;
#line 4013 "chess-state.c"
}


static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result = FALSE;
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 4026 "chess-state.c"
	{
		gint piece_index = 0;
#line 626 "../lib/chess-state.vala"
		piece_index = 0;
#line 4031 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 626 "../lib/chess-state.vala"
			while (TRUE) {
#line 4038 "chess-state.c"
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
#line 626 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 4048 "chess-state.c"
					gint _tmp1_;
#line 626 "../lib/chess-state.vala"
					_tmp1_ = piece_index;
#line 626 "../lib/chess-state.vala"
					piece_index = _tmp1_ + 1;
#line 4054 "chess-state.c"
				}
#line 626 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
				_tmp2_ = piece_index;
#line 626 "../lib/chess-state.vala"
				if (!(_tmp2_ < 64)) {
#line 626 "../lib/chess-state.vala"
					break;
#line 4064 "chess-state.c"
				}
#line 628 "../lib/chess-state.vala"
				_tmp3_ = piece_index;
#line 628 "../lib/chess-state.vala"
				_tmp4_ = self->board[_tmp3_];
#line 628 "../lib/chess-state.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 628 "../lib/chess-state.vala"
				p = _tmp5_;
#line 629 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 629 "../lib/chess-state.vala"
				if (_tmp7_ != NULL) {
#line 4078 "chess-state.c"
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
#line 629 "../lib/chess-state.vala"
					_tmp8_ = p;
#line 629 "../lib/chess-state.vala"
					_tmp9_ = _tmp8_->player;
#line 629 "../lib/chess-state.vala"
					_tmp6_ = _tmp9_ == player;
#line 4087 "chess-state.c"
				} else {
#line 629 "../lib/chess-state.vala"
					_tmp6_ = FALSE;
#line 4091 "chess-state.c"
				}
#line 629 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 4095 "chess-state.c"
					{
						gint end = 0;
#line 631 "../lib/chess-state.vala"
						end = 0;
#line 4100 "chess-state.c"
						{
							gboolean _tmp10_ = FALSE;
#line 631 "../lib/chess-state.vala"
							_tmp10_ = TRUE;
#line 631 "../lib/chess-state.vala"
							while (TRUE) {
#line 4107 "chess-state.c"
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
#line 631 "../lib/chess-state.vala"
								if (!_tmp10_) {
#line 4115 "chess-state.c"
									gint _tmp11_;
#line 631 "../lib/chess-state.vala"
									_tmp11_ = end;
#line 631 "../lib/chess-state.vala"
									end = _tmp11_ + 1;
#line 4121 "chess-state.c"
								}
#line 631 "../lib/chess-state.vala"
								_tmp10_ = FALSE;
#line 631 "../lib/chess-state.vala"
								_tmp12_ = end;
#line 631 "../lib/chess-state.vala"
								if (!(_tmp12_ < 64)) {
#line 631 "../lib/chess-state.vala"
									break;
#line 4131 "chess-state.c"
								}
#line 633 "../lib/chess-state.vala"
								_tmp13_ = piece_index;
#line 633 "../lib/chess-state.vala"
								_tmp14_ = piece_index;
#line 633 "../lib/chess-state.vala"
								_tmp15_ = end;
#line 633 "../lib/chess-state.vala"
								_tmp16_ = end;
#line 633 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 637 "../lib/chess-state.vala"
									result = FALSE;
#line 637 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 637 "../lib/chess-state.vala"
									return result;
#line 4149 "chess-state.c"
								}
							}
						}
					}
				}
#line 626 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4157 "chess-state.c"
			}
		}
	}
#line 642 "../lib/chess-state.vala"
	result = TRUE;
#line 642 "../lib/chess-state.vala"
	return result;
#line 4165 "chess-state.c"
}


static gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean result = FALSE;
	gboolean have_pieces = FALSE;
	gboolean _tmp17_;
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 647 "../lib/chess-state.vala"
	have_pieces = FALSE;
#line 4182 "chess-state.c"
	{
		gint start = 0;
#line 649 "../lib/chess-state.vala"
		start = 0;
#line 4187 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 649 "../lib/chess-state.vala"
			while (TRUE) {
#line 4194 "chess-state.c"
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
#line 649 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 4204 "chess-state.c"
					gint _tmp1_;
#line 649 "../lib/chess-state.vala"
					_tmp1_ = start;
#line 649 "../lib/chess-state.vala"
					start = _tmp1_ + 1;
#line 4210 "chess-state.c"
				}
#line 649 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
				_tmp2_ = start;
#line 649 "../lib/chess-state.vala"
				if (!(_tmp2_ < 64)) {
#line 649 "../lib/chess-state.vala"
					break;
#line 4220 "chess-state.c"
				}
#line 651 "../lib/chess-state.vala"
				_tmp3_ = start;
#line 651 "../lib/chess-state.vala"
				_tmp4_ = self->board[_tmp3_];
#line 651 "../lib/chess-state.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 651 "../lib/chess-state.vala"
				p = _tmp5_;
#line 652 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 652 "../lib/chess-state.vala"
				if (_tmp7_ != NULL) {
#line 4234 "chess-state.c"
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
#line 652 "../lib/chess-state.vala"
					_tmp8_ = p;
#line 652 "../lib/chess-state.vala"
					_tmp9_ = _tmp8_->player;
#line 652 "../lib/chess-state.vala"
					_tmp6_ = _tmp9_ == player;
#line 4243 "chess-state.c"
				} else {
#line 652 "../lib/chess-state.vala"
					_tmp6_ = FALSE;
#line 4247 "chess-state.c"
				}
#line 652 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 654 "../lib/chess-state.vala"
					have_pieces = TRUE;
#line 4253 "chess-state.c"
					{
						gint end = 0;
#line 657 "../lib/chess-state.vala"
						end = 0;
#line 4258 "chess-state.c"
						{
							gboolean _tmp10_ = FALSE;
#line 657 "../lib/chess-state.vala"
							_tmp10_ = TRUE;
#line 657 "../lib/chess-state.vala"
							while (TRUE) {
#line 4265 "chess-state.c"
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
#line 657 "../lib/chess-state.vala"
								if (!_tmp10_) {
#line 4273 "chess-state.c"
									gint _tmp11_;
#line 657 "../lib/chess-state.vala"
									_tmp11_ = end;
#line 657 "../lib/chess-state.vala"
									end = _tmp11_ + 1;
#line 4279 "chess-state.c"
								}
#line 657 "../lib/chess-state.vala"
								_tmp10_ = FALSE;
#line 657 "../lib/chess-state.vala"
								_tmp12_ = end;
#line 657 "../lib/chess-state.vala"
								if (!(_tmp12_ < 64)) {
#line 657 "../lib/chess-state.vala"
									break;
#line 4289 "chess-state.c"
								}
#line 659 "../lib/chess-state.vala"
								_tmp13_ = start;
#line 659 "../lib/chess-state.vala"
								_tmp14_ = start;
#line 659 "../lib/chess-state.vala"
								_tmp15_ = end;
#line 659 "../lib/chess-state.vala"
								_tmp16_ = end;
#line 659 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 663 "../lib/chess-state.vala"
									result = TRUE;
#line 663 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 663 "../lib/chess-state.vala"
									return result;
#line 4307 "chess-state.c"
								}
							}
						}
					}
				}
#line 649 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4315 "chess-state.c"
			}
		}
	}
#line 669 "../lib/chess-state.vala"
	_tmp17_ = have_pieces;
#line 669 "../lib/chess-state.vala"
	if (_tmp17_) {
#line 670 "../lib/chess-state.vala"
		result = FALSE;
#line 670 "../lib/chess-state.vala"
		return result;
#line 4327 "chess-state.c"
	} else {
#line 672 "../lib/chess-state.vala"
		result = TRUE;
#line 672 "../lib/chess-state.vala"
		return result;
#line 4333 "chess-state.c"
	}
}


gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gboolean result = FALSE;
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
#line 675 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 677 "../lib/chess-state.vala"
	white_knight_count = 0;
#line 678 "../lib/chess-state.vala"
	white_bishop_count = 0;
#line 679 "../lib/chess-state.vala"
	white_bishop_on_white_square = FALSE;
#line 680 "../lib/chess-state.vala"
	white_bishop_on_black_square = FALSE;
#line 681 "../lib/chess-state.vala"
	black_knight_count = 0;
#line 682 "../lib/chess-state.vala"
	black_bishop_count = 0;
#line 683 "../lib/chess-state.vala"
	black_bishop_on_white_square = FALSE;
#line 684 "../lib/chess-state.vala"
	black_bishop_on_black_square = FALSE;
#line 4368 "chess-state.c"
	{
		gint i = 0;
#line 686 "../lib/chess-state.vala"
		i = 0;
#line 4373 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 686 "../lib/chess-state.vala"
			while (TRUE) {
#line 4380 "chess-state.c"
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				ChessPiece* _tmp6_;
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				ChessPiece* _tmp9_;
				PieceType _tmp10_;
				ChessPiece* _tmp15_;
				PieceType _tmp16_;
				ChessPiece* _tmp22_;
				PieceType _tmp23_;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gboolean _tmp39_ = FALSE;
				gint _tmp40_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_;
				gboolean _tmp48_ = FALSE;
				gboolean _tmp49_ = FALSE;
				gint _tmp50_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				gint _tmp55_;
				gboolean _tmp58_ = FALSE;
				gint _tmp59_;
#line 686 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 4415 "chess-state.c"
					gint _tmp1_;
#line 686 "../lib/chess-state.vala"
					_tmp1_ = i;
#line 686 "../lib/chess-state.vala"
					i = _tmp1_ + 1;
#line 4421 "chess-state.c"
				}
#line 686 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
				_tmp2_ = i;
#line 686 "../lib/chess-state.vala"
				if (!(_tmp2_ < 64)) {
#line 686 "../lib/chess-state.vala"
					break;
#line 4431 "chess-state.c"
				}
#line 688 "../lib/chess-state.vala"
				_tmp3_ = i;
#line 688 "../lib/chess-state.vala"
				_tmp4_ = self->board[_tmp3_];
#line 688 "../lib/chess-state.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 688 "../lib/chess-state.vala"
				p = _tmp5_;
#line 689 "../lib/chess-state.vala"
				_tmp6_ = p;
#line 689 "../lib/chess-state.vala"
				if (_tmp6_ == NULL) {
#line 690 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 690 "../lib/chess-state.vala"
					continue;
#line 4449 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				_tmp9_ = p;
#line 693 "../lib/chess-state.vala"
				_tmp10_ = _tmp9_->type;
#line 693 "../lib/chess-state.vala"
				if (_tmp10_ == PIECE_TYPE_PAWN) {
#line 693 "../lib/chess-state.vala"
					_tmp8_ = TRUE;
#line 4459 "chess-state.c"
				} else {
					ChessPiece* _tmp11_;
					PieceType _tmp12_;
#line 693 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp12_ = _tmp11_->type;
#line 693 "../lib/chess-state.vala"
					_tmp8_ = _tmp12_ == PIECE_TYPE_ROOK;
#line 4469 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp8_) {
#line 693 "../lib/chess-state.vala"
					_tmp7_ = TRUE;
#line 4475 "chess-state.c"
				} else {
					ChessPiece* _tmp13_;
					PieceType _tmp14_;
#line 693 "../lib/chess-state.vala"
					_tmp13_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp14_ = _tmp13_->type;
#line 693 "../lib/chess-state.vala"
					_tmp7_ = _tmp14_ == PIECE_TYPE_QUEEN;
#line 4485 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp7_) {
#line 694 "../lib/chess-state.vala"
					result = TRUE;
#line 694 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 694 "../lib/chess-state.vala"
					return result;
#line 4495 "chess-state.c"
				}
#line 697 "../lib/chess-state.vala"
				_tmp15_ = p;
#line 697 "../lib/chess-state.vala"
				_tmp16_ = _tmp15_->type;
#line 697 "../lib/chess-state.vala"
				if (_tmp16_ == PIECE_TYPE_KNIGHT) {
#line 4503 "chess-state.c"
					ChessPiece* _tmp17_;
					Color _tmp18_;
					Color _tmp19_;
#line 699 "../lib/chess-state.vala"
					_tmp17_ = p;
#line 699 "../lib/chess-state.vala"
					_tmp18_ = chess_piece_get_color (_tmp17_);
#line 699 "../lib/chess-state.vala"
					_tmp19_ = _tmp18_;
#line 699 "../lib/chess-state.vala"
					if (_tmp19_ == COLOR_WHITE) {
#line 4515 "chess-state.c"
						gint _tmp20_;
#line 700 "../lib/chess-state.vala"
						_tmp20_ = white_knight_count;
#line 700 "../lib/chess-state.vala"
						white_knight_count = _tmp20_ + 1;
#line 4521 "chess-state.c"
					} else {
						gint _tmp21_;
#line 702 "../lib/chess-state.vala"
						_tmp21_ = black_knight_count;
#line 702 "../lib/chess-state.vala"
						black_knight_count = _tmp21_ + 1;
#line 4528 "chess-state.c"
					}
				}
#line 705 "../lib/chess-state.vala"
				_tmp22_ = p;
#line 705 "../lib/chess-state.vala"
				_tmp23_ = _tmp22_->type;
#line 705 "../lib/chess-state.vala"
				if (_tmp23_ == PIECE_TYPE_BISHOP) {
#line 4537 "chess-state.c"
					Color color = 0;
					gint _tmp24_;
					gint _tmp25_;
					ChessPiece* _tmp26_;
					Color _tmp27_;
					Color _tmp28_;
#line 707 "../lib/chess-state.vala"
					color = COLOR_BLACK;
#line 708 "../lib/chess-state.vala"
					_tmp24_ = i;
#line 708 "../lib/chess-state.vala"
					_tmp25_ = i;
#line 708 "../lib/chess-state.vala"
					if (((_tmp24_ + (_tmp25_ / 8)) % 2) != 0) {
#line 709 "../lib/chess-state.vala"
						color = COLOR_WHITE;
#line 4554 "chess-state.c"
					}
#line 711 "../lib/chess-state.vala"
					_tmp26_ = p;
#line 711 "../lib/chess-state.vala"
					_tmp27_ = chess_piece_get_color (_tmp26_);
#line 711 "../lib/chess-state.vala"
					_tmp28_ = _tmp27_;
#line 711 "../lib/chess-state.vala"
					if (_tmp28_ == COLOR_WHITE) {
#line 4564 "chess-state.c"
						Color _tmp29_;
						gint _tmp30_;
#line 713 "../lib/chess-state.vala"
						_tmp29_ = color;
#line 713 "../lib/chess-state.vala"
						if (_tmp29_ == COLOR_WHITE) {
#line 714 "../lib/chess-state.vala"
							white_bishop_on_white_square = TRUE;
#line 4573 "chess-state.c"
						} else {
#line 716 "../lib/chess-state.vala"
							white_bishop_on_black_square = TRUE;
#line 4577 "chess-state.c"
						}
#line 717 "../lib/chess-state.vala"
						_tmp30_ = white_bishop_count;
#line 717 "../lib/chess-state.vala"
						white_bishop_count = _tmp30_ + 1;
#line 4583 "chess-state.c"
					} else {
						Color _tmp31_;
						gint _tmp32_;
#line 721 "../lib/chess-state.vala"
						_tmp31_ = color;
#line 721 "../lib/chess-state.vala"
						if (_tmp31_ == COLOR_WHITE) {
#line 722 "../lib/chess-state.vala"
							black_bishop_on_white_square = TRUE;
#line 4593 "chess-state.c"
						} else {
#line 724 "../lib/chess-state.vala"
							black_bishop_on_black_square = TRUE;
#line 4597 "chess-state.c"
						}
#line 725 "../lib/chess-state.vala"
						_tmp32_ = black_bishop_count;
#line 725 "../lib/chess-state.vala"
						black_bishop_count = _tmp32_ + 1;
#line 4603 "chess-state.c"
					}
				}
#line 759 "../lib/chess-state.vala"
				_tmp34_ = white_knight_count;
#line 759 "../lib/chess-state.vala"
				if (_tmp34_ > 1) {
#line 759 "../lib/chess-state.vala"
					_tmp33_ = TRUE;
#line 4612 "chess-state.c"
				} else {
					gint _tmp35_;
#line 759 "../lib/chess-state.vala"
					_tmp35_ = black_knight_count;
#line 759 "../lib/chess-state.vala"
					_tmp33_ = _tmp35_ > 1;
#line 4619 "chess-state.c"
				}
#line 759 "../lib/chess-state.vala"
				if (_tmp33_) {
#line 760 "../lib/chess-state.vala"
					result = TRUE;
#line 760 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 760 "../lib/chess-state.vala"
					return result;
#line 4629 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				_tmp37_ = white_bishop_count;
#line 763 "../lib/chess-state.vala"
				if (_tmp37_ > 0) {
#line 4635 "chess-state.c"
					gint _tmp38_;
#line 763 "../lib/chess-state.vala"
					_tmp38_ = white_knight_count;
#line 763 "../lib/chess-state.vala"
					_tmp36_ = _tmp38_ > 0;
#line 4641 "chess-state.c"
				} else {
#line 763 "../lib/chess-state.vala"
					_tmp36_ = FALSE;
#line 4645 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				if (_tmp36_) {
#line 764 "../lib/chess-state.vala"
					result = TRUE;
#line 764 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 764 "../lib/chess-state.vala"
					return result;
#line 4655 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				_tmp40_ = black_bishop_count;
#line 765 "../lib/chess-state.vala"
				if (_tmp40_ > 0) {
#line 4661 "chess-state.c"
					gint _tmp41_;
#line 765 "../lib/chess-state.vala"
					_tmp41_ = black_knight_count;
#line 765 "../lib/chess-state.vala"
					_tmp39_ = _tmp41_ > 0;
#line 4667 "chess-state.c"
				} else {
#line 765 "../lib/chess-state.vala"
					_tmp39_ = FALSE;
#line 4671 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				if (_tmp39_) {
#line 766 "../lib/chess-state.vala"
					result = TRUE;
#line 766 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 766 "../lib/chess-state.vala"
					return result;
#line 4681 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				_tmp43_ = white_bishop_on_white_square;
#line 769 "../lib/chess-state.vala"
				if (_tmp43_) {
#line 4687 "chess-state.c"
					gboolean _tmp44_;
#line 769 "../lib/chess-state.vala"
					_tmp44_ = white_bishop_on_black_square;
#line 769 "../lib/chess-state.vala"
					_tmp42_ = _tmp44_;
#line 4693 "chess-state.c"
				} else {
#line 769 "../lib/chess-state.vala"
					_tmp42_ = FALSE;
#line 4697 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				if (_tmp42_) {
#line 770 "../lib/chess-state.vala"
					result = TRUE;
#line 770 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 770 "../lib/chess-state.vala"
					return result;
#line 4707 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				_tmp46_ = black_bishop_on_white_square;
#line 771 "../lib/chess-state.vala"
				if (_tmp46_) {
#line 4713 "chess-state.c"
					gboolean _tmp47_;
#line 771 "../lib/chess-state.vala"
					_tmp47_ = black_bishop_on_black_square;
#line 771 "../lib/chess-state.vala"
					_tmp45_ = _tmp47_;
#line 4719 "chess-state.c"
				} else {
#line 771 "../lib/chess-state.vala"
					_tmp45_ = FALSE;
#line 4723 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				if (_tmp45_) {
#line 772 "../lib/chess-state.vala"
					result = TRUE;
#line 772 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 772 "../lib/chess-state.vala"
					return result;
#line 4733 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				_tmp50_ = white_bishop_count;
#line 775 "../lib/chess-state.vala"
				if (_tmp50_ > 0) {
#line 775 "../lib/chess-state.vala"
					_tmp49_ = TRUE;
#line 4741 "chess-state.c"
				} else {
					gint _tmp51_;
#line 775 "../lib/chess-state.vala"
					_tmp51_ = white_knight_count;
#line 775 "../lib/chess-state.vala"
					_tmp49_ = _tmp51_ > 0;
#line 4748 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp49_) {
#line 4752 "chess-state.c"
					gint _tmp52_;
#line 775 "../lib/chess-state.vala"
					_tmp52_ = black_knight_count;
#line 775 "../lib/chess-state.vala"
					_tmp48_ = _tmp52_ > 0;
#line 4758 "chess-state.c"
				} else {
#line 775 "../lib/chess-state.vala"
					_tmp48_ = FALSE;
#line 4762 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp48_) {
#line 776 "../lib/chess-state.vala"
					result = TRUE;
#line 776 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 776 "../lib/chess-state.vala"
					return result;
#line 4772 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				_tmp55_ = black_bishop_count;
#line 777 "../lib/chess-state.vala"
				if (_tmp55_ > 0) {
#line 777 "../lib/chess-state.vala"
					_tmp54_ = TRUE;
#line 4780 "chess-state.c"
				} else {
					gint _tmp56_;
#line 777 "../lib/chess-state.vala"
					_tmp56_ = black_knight_count;
#line 777 "../lib/chess-state.vala"
					_tmp54_ = _tmp56_ > 0;
#line 4787 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp54_) {
#line 4791 "chess-state.c"
					gint _tmp57_;
#line 777 "../lib/chess-state.vala"
					_tmp57_ = white_knight_count;
#line 777 "../lib/chess-state.vala"
					_tmp53_ = _tmp57_ > 0;
#line 4797 "chess-state.c"
				} else {
#line 777 "../lib/chess-state.vala"
					_tmp53_ = FALSE;
#line 4801 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp53_) {
#line 778 "../lib/chess-state.vala"
					result = TRUE;
#line 778 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 778 "../lib/chess-state.vala"
					return result;
#line 4811 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				_tmp59_ = white_bishop_count;
#line 781 "../lib/chess-state.vala"
				if (_tmp59_ > 0) {
#line 4817 "chess-state.c"
					gint _tmp60_;
#line 781 "../lib/chess-state.vala"
					_tmp60_ = black_bishop_count;
#line 781 "../lib/chess-state.vala"
					_tmp58_ = _tmp60_ > 0;
#line 4823 "chess-state.c"
				} else {
#line 781 "../lib/chess-state.vala"
					_tmp58_ = FALSE;
#line 4827 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				if (_tmp58_) {
#line 4831 "chess-state.c"
					gboolean _tmp61_ = FALSE;
					gboolean _tmp62_;
#line 783 "../lib/chess-state.vala"
					_tmp62_ = white_bishop_on_white_square;
#line 783 "../lib/chess-state.vala"
					if (_tmp62_) {
#line 4838 "chess-state.c"
						gboolean _tmp63_;
#line 783 "../lib/chess-state.vala"
						_tmp63_ = black_bishop_on_black_square;
#line 783 "../lib/chess-state.vala"
						_tmp61_ = _tmp63_;
#line 4844 "chess-state.c"
					} else {
#line 783 "../lib/chess-state.vala"
						_tmp61_ = FALSE;
#line 4848 "chess-state.c"
					}
#line 783 "../lib/chess-state.vala"
					if (_tmp61_) {
#line 784 "../lib/chess-state.vala"
						result = TRUE;
#line 784 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 784 "../lib/chess-state.vala"
						return result;
#line 4858 "chess-state.c"
					} else {
						gboolean _tmp64_ = FALSE;
						gboolean _tmp65_;
#line 785 "../lib/chess-state.vala"
						_tmp65_ = white_bishop_on_black_square;
#line 785 "../lib/chess-state.vala"
						if (_tmp65_) {
#line 4866 "chess-state.c"
							gboolean _tmp66_;
#line 785 "../lib/chess-state.vala"
							_tmp66_ = black_bishop_on_white_square;
#line 785 "../lib/chess-state.vala"
							_tmp64_ = _tmp66_;
#line 4872 "chess-state.c"
						} else {
#line 785 "../lib/chess-state.vala"
							_tmp64_ = FALSE;
#line 4876 "chess-state.c"
						}
#line 785 "../lib/chess-state.vala"
						if (_tmp64_) {
#line 786 "../lib/chess-state.vala"
							result = TRUE;
#line 786 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 786 "../lib/chess-state.vala"
							return result;
#line 4886 "chess-state.c"
						}
					}
				}
#line 686 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4892 "chess-state.c"
			}
		}
	}
#line 790 "../lib/chess-state.vala"
	result = FALSE;
#line 790 "../lib/chess-state.vala"
	return result;
#line 4900 "chess-state.c"
}


static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result = FALSE;
#line 793 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../lib/chess-state.vala"
	_vala_type = PIECE_TYPE_PAWN;
#line 796 "../lib/chess-state.vala"
	switch (c) {
#line 796 "../lib/chess-state.vala"
		case 'P':
#line 4919 "chess-state.c"
		{
#line 799 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_PAWN;
#line 800 "../lib/chess-state.vala"
			result = TRUE;
#line 800 "../lib/chess-state.vala"
			if (type) {
#line 800 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4929 "chess-state.c"
			}
#line 800 "../lib/chess-state.vala"
			return result;
#line 4933 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'R':
#line 4937 "chess-state.c"
		{
#line 802 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_ROOK;
#line 803 "../lib/chess-state.vala"
			result = TRUE;
#line 803 "../lib/chess-state.vala"
			if (type) {
#line 803 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4947 "chess-state.c"
			}
#line 803 "../lib/chess-state.vala"
			return result;
#line 4951 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'N':
#line 4955 "chess-state.c"
		{
#line 805 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KNIGHT;
#line 806 "../lib/chess-state.vala"
			result = TRUE;
#line 806 "../lib/chess-state.vala"
			if (type) {
#line 806 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4965 "chess-state.c"
			}
#line 806 "../lib/chess-state.vala"
			return result;
#line 4969 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'B':
#line 4973 "chess-state.c"
		{
#line 808 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_BISHOP;
#line 809 "../lib/chess-state.vala"
			result = TRUE;
#line 809 "../lib/chess-state.vala"
			if (type) {
#line 809 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4983 "chess-state.c"
			}
#line 809 "../lib/chess-state.vala"
			return result;
#line 4987 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'Q':
#line 4991 "chess-state.c"
		{
#line 811 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_QUEEN;
#line 812 "../lib/chess-state.vala"
			result = TRUE;
#line 812 "../lib/chess-state.vala"
			if (type) {
#line 812 "../lib/chess-state.vala"
				*type = _vala_type;
#line 5001 "chess-state.c"
			}
#line 812 "../lib/chess-state.vala"
			return result;
#line 5005 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'K':
#line 5009 "chess-state.c"
		{
#line 814 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KING;
#line 815 "../lib/chess-state.vala"
			result = TRUE;
#line 815 "../lib/chess-state.vala"
			if (type) {
#line 815 "../lib/chess-state.vala"
				*type = _vala_type;
#line 5019 "chess-state.c"
			}
#line 815 "../lib/chess-state.vala"
			return result;
#line 5023 "chess-state.c"
		}
		default:
		{
#line 817 "../lib/chess-state.vala"
			result = FALSE;
#line 817 "../lib/chess-state.vala"
			if (type) {
#line 817 "../lib/chess-state.vala"
				*type = _vala_type;
#line 5033 "chess-state.c"
			}
#line 817 "../lib/chess-state.vala"
			return result;
#line 5037 "chess-state.c"
		}
	}
#line 793 "../lib/chess-state.vala"
	if (type) {
#line 793 "../lib/chess-state.vala"
		*type = _vala_type;
#line 5044 "chess-state.c"
	}
}


static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gboolean result = FALSE;
	gint i = 0;
	gint _tmp99_;
	gint _tmp103_;
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 823 "../lib/chess-state.vala"
	i = 0;
#line 825 "../lib/chess-state.vala"
	_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 826 "../lib/chess-state.vala"
	if (g_str_has_prefix (move, "O-O-O")) {
#line 5080 "chess-state.c"
		Color _tmp0_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 828 "../lib/chess-state.vala"
		_tmp0_ = player->color;
#line 828 "../lib/chess-state.vala"
		if (_tmp0_ == COLOR_WHITE) {
#line 5089 "chess-state.c"
			gint _tmp1_;
#line 829 "../lib/chess-state.vala"
			_vala_r1 = 0;
#line 829 "../lib/chess-state.vala"
			_tmp1_ = _vala_r1;
#line 829 "../lib/chess-state.vala"
			_vala_r0 = _tmp1_;
#line 5097 "chess-state.c"
		} else {
			gint _tmp2_;
#line 831 "../lib/chess-state.vala"
			_vala_r1 = 7;
#line 831 "../lib/chess-state.vala"
			_tmp2_ = _vala_r1;
#line 831 "../lib/chess-state.vala"
			_vala_r0 = _tmp2_;
#line 5106 "chess-state.c"
		}
#line 832 "../lib/chess-state.vala"
		_vala_f0 = 4;
#line 833 "../lib/chess-state.vala"
		_vala_f1 = 2;
#line 834 "../lib/chess-state.vala"
		_tmp3_ = i;
#line 834 "../lib/chess-state.vala"
		_tmp4_ = strlen ("O-O-O");
#line 834 "../lib/chess-state.vala"
		_tmp5_ = _tmp4_;
#line 834 "../lib/chess-state.vala"
		i = _tmp3_ + ((gint) _tmp5_);
#line 5120 "chess-state.c"
	} else {
#line 836 "../lib/chess-state.vala"
		if (g_str_has_prefix (move, "O-O")) {
#line 5124 "chess-state.c"
			Color _tmp6_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 838 "../lib/chess-state.vala"
			_tmp6_ = player->color;
#line 838 "../lib/chess-state.vala"
			if (_tmp6_ == COLOR_WHITE) {
#line 5133 "chess-state.c"
				gint _tmp7_;
#line 839 "../lib/chess-state.vala"
				_vala_r1 = 0;
#line 839 "../lib/chess-state.vala"
				_tmp7_ = _vala_r1;
#line 839 "../lib/chess-state.vala"
				_vala_r0 = _tmp7_;
#line 5141 "chess-state.c"
			} else {
				gint _tmp8_;
#line 841 "../lib/chess-state.vala"
				_vala_r1 = 7;
#line 841 "../lib/chess-state.vala"
				_tmp8_ = _vala_r1;
#line 841 "../lib/chess-state.vala"
				_vala_r0 = _tmp8_;
#line 5150 "chess-state.c"
			}
#line 842 "../lib/chess-state.vala"
			_vala_f0 = 4;
#line 843 "../lib/chess-state.vala"
			_vala_f1 = 6;
#line 844 "../lib/chess-state.vala"
			_tmp9_ = i;
#line 844 "../lib/chess-state.vala"
			_tmp10_ = strlen ("O-O");
#line 844 "../lib/chess-state.vala"
			_tmp11_ = _tmp10_;
#line 844 "../lib/chess-state.vala"
			i = _tmp9_ + ((gint) _tmp11_);
#line 5164 "chess-state.c"
		} else {
			PieceType type = 0;
			gint _tmp12_;
			PieceType _tmp13_ = 0;
			gboolean _tmp14_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			gboolean _tmp24_ = FALSE;
			gint _tmp25_;
			gboolean _tmp29_ = FALSE;
			gint _tmp30_;
			gboolean _tmp33_ = FALSE;
			gint _tmp34_;
			gboolean _tmp39_ = FALSE;
			gint _tmp40_;
			gint _tmp45_;
			gboolean _tmp57_ = FALSE;
			gint _tmp58_;
			gboolean _tmp60_ = FALSE;
			gint _tmp61_;
#line 848 "../lib/chess-state.vala"
			type = PIECE_TYPE_PAWN;
#line 849 "../lib/chess-state.vala"
			_tmp12_ = i;
#line 849 "../lib/chess-state.vala"
			_tmp14_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp12_), &_tmp13_);
#line 849 "../lib/chess-state.vala"
			type = _tmp13_;
#line 849 "../lib/chess-state.vala"
			if (_tmp14_) {
#line 5198 "chess-state.c"
				gint _tmp15_;
#line 850 "../lib/chess-state.vala"
				_tmp15_ = i;
#line 850 "../lib/chess-state.vala"
				i = _tmp15_ + 1;
#line 5204 "chess-state.c"
			}
#line 852 "../lib/chess-state.vala"
			_vala_f1 = -1;
#line 852 "../lib/chess-state.vala"
			_tmp16_ = _vala_f1;
#line 852 "../lib/chess-state.vala"
			_vala_r1 = _tmp16_;
#line 852 "../lib/chess-state.vala"
			_tmp17_ = _vala_r1;
#line 852 "../lib/chess-state.vala"
			_vala_f0 = _tmp17_;
#line 852 "../lib/chess-state.vala"
			_tmp18_ = _vala_f0;
#line 852 "../lib/chess-state.vala"
			_vala_r0 = _tmp18_;
#line 853 "../lib/chess-state.vala"
			_tmp20_ = i;
#line 853 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp20_) >= 'a') {
#line 5224 "chess-state.c"
				gint _tmp21_;
#line 853 "../lib/chess-state.vala"
				_tmp21_ = i;
#line 853 "../lib/chess-state.vala"
				_tmp19_ = string_get (move, (glong) _tmp21_) <= 'h';
#line 5230 "chess-state.c"
			} else {
#line 853 "../lib/chess-state.vala"
				_tmp19_ = FALSE;
#line 5234 "chess-state.c"
			}
#line 853 "../lib/chess-state.vala"
			if (_tmp19_) {
#line 5238 "chess-state.c"
				gint _tmp22_;
				gint _tmp23_;
#line 855 "../lib/chess-state.vala"
				_tmp22_ = i;
#line 855 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) _tmp22_) - 'a');
#line 856 "../lib/chess-state.vala"
				_tmp23_ = i;
#line 856 "../lib/chess-state.vala"
				i = _tmp23_ + 1;
#line 5249 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			_tmp25_ = i;
#line 858 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp25_) >= '1') {
#line 5255 "chess-state.c"
				gint _tmp26_;
#line 858 "../lib/chess-state.vala"
				_tmp26_ = i;
#line 858 "../lib/chess-state.vala"
				_tmp24_ = string_get (move, (glong) _tmp26_) <= '8';
#line 5261 "chess-state.c"
			} else {
#line 858 "../lib/chess-state.vala"
				_tmp24_ = FALSE;
#line 5265 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			if (_tmp24_) {
#line 5269 "chess-state.c"
				gint _tmp27_;
				gint _tmp28_;
#line 860 "../lib/chess-state.vala"
				_tmp27_ = i;
#line 860 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) _tmp27_) - '1');
#line 861 "../lib/chess-state.vala"
				_tmp28_ = i;
#line 861 "../lib/chess-state.vala"
				i = _tmp28_ + 1;
#line 5280 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			_tmp30_ = i;
#line 863 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp30_) == 'x') {
#line 863 "../lib/chess-state.vala"
				_tmp29_ = TRUE;
#line 5288 "chess-state.c"
			} else {
				gint _tmp31_;
#line 863 "../lib/chess-state.vala"
				_tmp31_ = i;
#line 863 "../lib/chess-state.vala"
				_tmp29_ = string_get (move, (glong) _tmp31_) == '-';
#line 5295 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			if (_tmp29_) {
#line 5299 "chess-state.c"
				gint _tmp32_;
#line 864 "../lib/chess-state.vala"
				_tmp32_ = i;
#line 864 "../lib/chess-state.vala"
				i = _tmp32_ + 1;
#line 5305 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			_tmp34_ = i;
#line 865 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp34_) >= 'a') {
#line 5311 "chess-state.c"
				gint _tmp35_;
#line 865 "../lib/chess-state.vala"
				_tmp35_ = i;
#line 865 "../lib/chess-state.vala"
				_tmp33_ = string_get (move, (glong) _tmp35_) <= 'h';
#line 5317 "chess-state.c"
			} else {
#line 865 "../lib/chess-state.vala"
				_tmp33_ = FALSE;
#line 5321 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			if (_tmp33_) {
#line 5325 "chess-state.c"
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
#line 867 "../lib/chess-state.vala"
				_tmp36_ = _vala_f1;
#line 867 "../lib/chess-state.vala"
				_vala_f0 = _tmp36_;
#line 868 "../lib/chess-state.vala"
				_tmp37_ = i;
#line 868 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) _tmp37_) - 'a');
#line 869 "../lib/chess-state.vala"
				_tmp38_ = i;
#line 869 "../lib/chess-state.vala"
				i = _tmp38_ + 1;
#line 5341 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			_tmp40_ = i;
#line 871 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp40_) >= '1') {
#line 5347 "chess-state.c"
				gint _tmp41_;
#line 871 "../lib/chess-state.vala"
				_tmp41_ = i;
#line 871 "../lib/chess-state.vala"
				_tmp39_ = string_get (move, (glong) _tmp41_) <= '8';
#line 5353 "chess-state.c"
			} else {
#line 871 "../lib/chess-state.vala"
				_tmp39_ = FALSE;
#line 5357 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			if (_tmp39_) {
#line 5361 "chess-state.c"
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
#line 873 "../lib/chess-state.vala"
				_tmp42_ = _vala_r1;
#line 873 "../lib/chess-state.vala"
				_vala_r0 = _tmp42_;
#line 874 "../lib/chess-state.vala"
				_tmp43_ = i;
#line 874 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) _tmp43_) - '1');
#line 875 "../lib/chess-state.vala"
				_tmp44_ = i;
#line 875 "../lib/chess-state.vala"
				i = _tmp44_ + 1;
#line 5377 "chess-state.c"
			}
#line 877 "../lib/chess-state.vala"
			_tmp45_ = i;
#line 877 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp45_) == '=') {
#line 5383 "chess-state.c"
				gint _tmp46_;
				gint _tmp47_;
				PieceType _tmp48_ = 0;
				gboolean _tmp49_;
#line 879 "../lib/chess-state.vala"
				_tmp46_ = i;
#line 879 "../lib/chess-state.vala"
				i = _tmp46_ + 1;
#line 880 "../lib/chess-state.vala"
				_tmp47_ = i;
#line 880 "../lib/chess-state.vala"
				_tmp49_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp47_), &_tmp48_);
#line 880 "../lib/chess-state.vala"
				_vala_promotion_type = _tmp48_;
#line 880 "../lib/chess-state.vala"
				if (_tmp49_) {
#line 5400 "chess-state.c"
					gint _tmp50_;
#line 881 "../lib/chess-state.vala"
					_tmp50_ = i;
#line 881 "../lib/chess-state.vala"
					i = _tmp50_ + 1;
#line 5406 "chess-state.c"
				}
			} else {
				gint _tmp51_;
#line 883 "../lib/chess-state.vala"
				_tmp51_ = i;
#line 883 "../lib/chess-state.vala"
				if (string_get (move, (glong) _tmp51_) != '\0') {
#line 5414 "chess-state.c"
					gint _tmp52_;
#line 885 "../lib/chess-state.vala"
					_tmp52_ = i;
#line 885 "../lib/chess-state.vala"
					switch (string_get (move, (glong) _tmp52_)) {
#line 885 "../lib/chess-state.vala"
						case 'q':
#line 885 "../lib/chess-state.vala"
						case 'Q':
#line 5424 "chess-state.c"
						{
							gint _tmp53_;
#line 889 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 890 "../lib/chess-state.vala"
							_tmp53_ = i;
#line 890 "../lib/chess-state.vala"
							i = _tmp53_ + 1;
#line 891 "../lib/chess-state.vala"
							break;
#line 5435 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'n':
#line 885 "../lib/chess-state.vala"
						case 'N':
#line 5441 "chess-state.c"
						{
							gint _tmp54_;
#line 894 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
#line 895 "../lib/chess-state.vala"
							_tmp54_ = i;
#line 895 "../lib/chess-state.vala"
							i = _tmp54_ + 1;
#line 896 "../lib/chess-state.vala"
							break;
#line 5452 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'r':
#line 885 "../lib/chess-state.vala"
						case 'R':
#line 5458 "chess-state.c"
						{
							gint _tmp55_;
#line 899 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_ROOK;
#line 900 "../lib/chess-state.vala"
							_tmp55_ = i;
#line 900 "../lib/chess-state.vala"
							i = _tmp55_ + 1;
#line 901 "../lib/chess-state.vala"
							break;
#line 5469 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'b':
#line 885 "../lib/chess-state.vala"
						case 'B':
#line 5475 "chess-state.c"
						{
							gint _tmp56_;
#line 904 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_BISHOP;
#line 905 "../lib/chess-state.vala"
							_tmp56_ = i;
#line 905 "../lib/chess-state.vala"
							i = _tmp56_ + 1;
#line 906 "../lib/chess-state.vala"
							break;
#line 5486 "chess-state.c"
						}
						default:
#line 885 "../lib/chess-state.vala"
						break;
#line 5491 "chess-state.c"
					}
				}
			}
#line 911 "../lib/chess-state.vala"
			_tmp58_ = _vala_r1;
#line 911 "../lib/chess-state.vala"
			if (_tmp58_ < 0) {
#line 911 "../lib/chess-state.vala"
				_tmp57_ = TRUE;
#line 5501 "chess-state.c"
			} else {
				gint _tmp59_;
#line 911 "../lib/chess-state.vala"
				_tmp59_ = _vala_f1;
#line 911 "../lib/chess-state.vala"
				_tmp57_ = _tmp59_ < 0;
#line 5508 "chess-state.c"
			}
#line 911 "../lib/chess-state.vala"
			if (_tmp57_) {
#line 913 "../lib/chess-state.vala"
				g_debug ("chess-state.vala:913: Move %s missing destination", move);
#line 914 "../lib/chess-state.vala"
				result = FALSE;
#line 914 "../lib/chess-state.vala"
				if (r0) {
#line 914 "../lib/chess-state.vala"
					*r0 = _vala_r0;
#line 5520 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f0) {
#line 914 "../lib/chess-state.vala"
					*f0 = _vala_f0;
#line 5526 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (r1) {
#line 914 "../lib/chess-state.vala"
					*r1 = _vala_r1;
#line 5532 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f1) {
#line 914 "../lib/chess-state.vala"
					*f1 = _vala_f1;
#line 5538 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (promotion_type) {
#line 914 "../lib/chess-state.vala"
					*promotion_type = _vala_promotion_type;
#line 5544 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				return result;
#line 5548 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			_tmp61_ = _vala_r0;
#line 918 "../lib/chess-state.vala"
			if (_tmp61_ < 0) {
#line 918 "../lib/chess-state.vala"
				_tmp60_ = TRUE;
#line 5556 "chess-state.c"
			} else {
				gint _tmp62_;
#line 918 "../lib/chess-state.vala"
				_tmp62_ = _vala_f0;
#line 918 "../lib/chess-state.vala"
				_tmp60_ = _tmp62_ < 0;
#line 5563 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			if (_tmp60_) {
#line 5567 "chess-state.c"
				gint match_rank = 0;
				gint match_file = 0;
				gint _tmp96_;
				gint _tmp97_;
				gint _tmp98_;
#line 920 "../lib/chess-state.vala"
				match_rank = -1;
#line 920 "../lib/chess-state.vala"
				match_file = -1;
#line 5577 "chess-state.c"
				{
					gint file = 0;
#line 922 "../lib/chess-state.vala"
					file = 0;
#line 5582 "chess-state.c"
					{
						gboolean _tmp63_ = FALSE;
#line 922 "../lib/chess-state.vala"
						_tmp63_ = TRUE;
#line 922 "../lib/chess-state.vala"
						while (TRUE) {
#line 5589 "chess-state.c"
							gint _tmp65_;
							gboolean _tmp66_ = FALSE;
							gint _tmp67_;
#line 922 "../lib/chess-state.vala"
							if (!_tmp63_) {
#line 5595 "chess-state.c"
								gint _tmp64_;
#line 922 "../lib/chess-state.vala"
								_tmp64_ = file;
#line 922 "../lib/chess-state.vala"
								file = _tmp64_ + 1;
#line 5601 "chess-state.c"
							}
#line 922 "../lib/chess-state.vala"
							_tmp63_ = FALSE;
#line 922 "../lib/chess-state.vala"
							_tmp65_ = file;
#line 922 "../lib/chess-state.vala"
							if (!(_tmp65_ < 8)) {
#line 922 "../lib/chess-state.vala"
								break;
#line 5611 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							_tmp67_ = _vala_f0;
#line 924 "../lib/chess-state.vala"
							if (_tmp67_ >= 0) {
#line 5617 "chess-state.c"
								gint _tmp68_;
								gint _tmp69_;
#line 924 "../lib/chess-state.vala"
								_tmp68_ = file;
#line 924 "../lib/chess-state.vala"
								_tmp69_ = _vala_f0;
#line 924 "../lib/chess-state.vala"
								_tmp66_ = _tmp68_ != _tmp69_;
#line 5626 "chess-state.c"
							} else {
#line 924 "../lib/chess-state.vala"
								_tmp66_ = FALSE;
#line 5630 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							if (_tmp66_) {
#line 925 "../lib/chess-state.vala"
								continue;
#line 5636 "chess-state.c"
							}
							{
								gint rank = 0;
#line 927 "../lib/chess-state.vala"
								rank = 0;
#line 5642 "chess-state.c"
								{
									gboolean _tmp70_ = FALSE;
#line 927 "../lib/chess-state.vala"
									_tmp70_ = TRUE;
#line 927 "../lib/chess-state.vala"
									while (TRUE) {
#line 5649 "chess-state.c"
										gint _tmp72_;
										gboolean _tmp73_ = FALSE;
										gint _tmp74_;
										ChessPiece* piece = NULL;
										gint _tmp77_;
										gint _tmp78_;
										ChessPiece* _tmp79_;
										ChessPiece* _tmp80_;
										gboolean _tmp81_ = FALSE;
										gboolean _tmp82_ = FALSE;
										ChessPiece* _tmp83_;
										gint _tmp89_;
										gint _tmp90_;
										gint _tmp91_;
										gint _tmp92_;
										gint _tmp93_;
										gint _tmp94_;
										gint _tmp95_;
#line 927 "../lib/chess-state.vala"
										if (!_tmp70_) {
#line 5670 "chess-state.c"
											gint _tmp71_;
#line 927 "../lib/chess-state.vala"
											_tmp71_ = rank;
#line 927 "../lib/chess-state.vala"
											rank = _tmp71_ + 1;
#line 5676 "chess-state.c"
										}
#line 927 "../lib/chess-state.vala"
										_tmp70_ = FALSE;
#line 927 "../lib/chess-state.vala"
										_tmp72_ = rank;
#line 927 "../lib/chess-state.vala"
										if (!(_tmp72_ < 8)) {
#line 927 "../lib/chess-state.vala"
											break;
#line 5686 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										_tmp74_ = _vala_r0;
#line 929 "../lib/chess-state.vala"
										if (_tmp74_ >= 0) {
#line 5692 "chess-state.c"
											gint _tmp75_;
											gint _tmp76_;
#line 929 "../lib/chess-state.vala"
											_tmp75_ = rank;
#line 929 "../lib/chess-state.vala"
											_tmp76_ = _vala_r0;
#line 929 "../lib/chess-state.vala"
											_tmp73_ = _tmp75_ != _tmp76_;
#line 5701 "chess-state.c"
										} else {
#line 929 "../lib/chess-state.vala"
											_tmp73_ = FALSE;
#line 5705 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										if (_tmp73_) {
#line 930 "../lib/chess-state.vala"
											continue;
#line 5711 "chess-state.c"
										}
#line 933 "../lib/chess-state.vala"
										_tmp77_ = rank;
#line 933 "../lib/chess-state.vala"
										_tmp78_ = file;
#line 933 "../lib/chess-state.vala"
										_tmp79_ = self->board[chess_state_get_index (self, _tmp77_, _tmp78_)];
#line 933 "../lib/chess-state.vala"
										_tmp80_ = _g_object_ref0 (_tmp79_);
#line 933 "../lib/chess-state.vala"
										piece = _tmp80_;
#line 934 "../lib/chess-state.vala"
										_tmp83_ = piece;
#line 934 "../lib/chess-state.vala"
										if (_tmp83_ == NULL) {
#line 934 "../lib/chess-state.vala"
											_tmp82_ = TRUE;
#line 5729 "chess-state.c"
										} else {
											ChessPiece* _tmp84_;
											PieceType _tmp85_;
											PieceType _tmp86_;
#line 934 "../lib/chess-state.vala"
											_tmp84_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp85_ = _tmp84_->type;
#line 934 "../lib/chess-state.vala"
											_tmp86_ = type;
#line 934 "../lib/chess-state.vala"
											_tmp82_ = _tmp85_ != _tmp86_;
#line 5742 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp82_) {
#line 934 "../lib/chess-state.vala"
											_tmp81_ = TRUE;
#line 5748 "chess-state.c"
										} else {
											ChessPiece* _tmp87_;
											ChessPlayer* _tmp88_;
#line 934 "../lib/chess-state.vala"
											_tmp87_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp88_ = _tmp87_->player;
#line 934 "../lib/chess-state.vala"
											_tmp81_ = _tmp88_ != player;
#line 5758 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp81_) {
#line 935 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 935 "../lib/chess-state.vala"
											continue;
#line 5766 "chess-state.c"
										}
#line 938 "../lib/chess-state.vala"
										_tmp89_ = rank;
#line 938 "../lib/chess-state.vala"
										_tmp90_ = file;
#line 938 "../lib/chess-state.vala"
										_tmp91_ = _vala_r1;
#line 938 "../lib/chess-state.vala"
										_tmp92_ = _vala_f1;
#line 938 "../lib/chess-state.vala"
										if (!chess_state_move_with_coords (self, player, _tmp89_, _tmp90_, _tmp91_, _tmp92_, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 939 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 939 "../lib/chess-state.vala"
											continue;
#line 5782 "chess-state.c"
										}
#line 942 "../lib/chess-state.vala"
										_tmp93_ = match_rank;
#line 942 "../lib/chess-state.vala"
										if (_tmp93_ >= 0) {
#line 944 "../lib/chess-state.vala"
											g_debug ("chess-state.vala:944: Move %s is ambiguous", move);
#line 945 "../lib/chess-state.vala"
											result = FALSE;
#line 945 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 945 "../lib/chess-state.vala"
											if (r0) {
#line 945 "../lib/chess-state.vala"
												*r0 = _vala_r0;
#line 5798 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f0) {
#line 945 "../lib/chess-state.vala"
												*f0 = _vala_f0;
#line 5804 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (r1) {
#line 945 "../lib/chess-state.vala"
												*r1 = _vala_r1;
#line 5810 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f1) {
#line 945 "../lib/chess-state.vala"
												*f1 = _vala_f1;
#line 5816 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (promotion_type) {
#line 945 "../lib/chess-state.vala"
												*promotion_type = _vala_promotion_type;
#line 5822 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											return result;
#line 5826 "chess-state.c"
										}
#line 948 "../lib/chess-state.vala"
										_tmp94_ = rank;
#line 948 "../lib/chess-state.vala"
										match_rank = _tmp94_;
#line 949 "../lib/chess-state.vala"
										_tmp95_ = file;
#line 949 "../lib/chess-state.vala"
										match_file = _tmp95_;
#line 927 "../lib/chess-state.vala"
										_g_object_unref0 (piece);
#line 5838 "chess-state.c"
									}
								}
							}
						}
					}
				}
#line 953 "../lib/chess-state.vala"
				_tmp96_ = match_rank;
#line 953 "../lib/chess-state.vala"
				if (_tmp96_ < 0) {
#line 955 "../lib/chess-state.vala"
					g_debug ("chess-state.vala:955: Move %s has no matches", move);
#line 956 "../lib/chess-state.vala"
					result = FALSE;
#line 956 "../lib/chess-state.vala"
					if (r0) {
#line 956 "../lib/chess-state.vala"
						*r0 = _vala_r0;
#line 5857 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f0) {
#line 956 "../lib/chess-state.vala"
						*f0 = _vala_f0;
#line 5863 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (r1) {
#line 956 "../lib/chess-state.vala"
						*r1 = _vala_r1;
#line 5869 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f1) {
#line 956 "../lib/chess-state.vala"
						*f1 = _vala_f1;
#line 5875 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (promotion_type) {
#line 956 "../lib/chess-state.vala"
						*promotion_type = _vala_promotion_type;
#line 5881 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					return result;
#line 5885 "chess-state.c"
				}
#line 959 "../lib/chess-state.vala"
				_tmp97_ = match_rank;
#line 959 "../lib/chess-state.vala"
				_vala_r0 = _tmp97_;
#line 960 "../lib/chess-state.vala"
				_tmp98_ = match_file;
#line 960 "../lib/chess-state.vala"
				_vala_f0 = _tmp98_;
#line 5895 "chess-state.c"
			}
		}
	}
#line 964 "../lib/chess-state.vala"
	_tmp99_ = i;
#line 964 "../lib/chess-state.vala"
	if (string_get (move, (glong) _tmp99_) == '+') {
#line 5903 "chess-state.c"
		gint _tmp100_;
#line 965 "../lib/chess-state.vala"
		_tmp100_ = i;
#line 965 "../lib/chess-state.vala"
		i = _tmp100_ + 1;
#line 5909 "chess-state.c"
	} else {
		gint _tmp101_;
#line 966 "../lib/chess-state.vala"
		_tmp101_ = i;
#line 966 "../lib/chess-state.vala"
		if (string_get (move, (glong) _tmp101_) == '#') {
#line 5916 "chess-state.c"
			gint _tmp102_;
#line 967 "../lib/chess-state.vala"
			_tmp102_ = i;
#line 967 "../lib/chess-state.vala"
			i = _tmp102_ + 1;
#line 5922 "chess-state.c"
		}
	}
#line 969 "../lib/chess-state.vala"
	_tmp103_ = i;
#line 969 "../lib/chess-state.vala"
	if (string_get (move, (glong) _tmp103_) != '\0') {
#line 971 "../lib/chess-state.vala"
		g_debug ("chess-state.vala:971: Move %s has unexpected characters", move);
#line 972 "../lib/chess-state.vala"
		result = FALSE;
#line 972 "../lib/chess-state.vala"
		if (r0) {
#line 972 "../lib/chess-state.vala"
			*r0 = _vala_r0;
#line 5937 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f0) {
#line 972 "../lib/chess-state.vala"
			*f0 = _vala_f0;
#line 5943 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (r1) {
#line 972 "../lib/chess-state.vala"
			*r1 = _vala_r1;
#line 5949 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f1) {
#line 972 "../lib/chess-state.vala"
			*f1 = _vala_f1;
#line 5955 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (promotion_type) {
#line 972 "../lib/chess-state.vala"
			*promotion_type = _vala_promotion_type;
#line 5961 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		return result;
#line 5965 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	result = TRUE;
#line 975 "../lib/chess-state.vala"
	if (r0) {
#line 975 "../lib/chess-state.vala"
		*r0 = _vala_r0;
#line 5973 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f0) {
#line 975 "../lib/chess-state.vala"
		*f0 = _vala_f0;
#line 5979 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (r1) {
#line 975 "../lib/chess-state.vala"
		*r1 = _vala_r1;
#line 5985 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f1) {
#line 975 "../lib/chess-state.vala"
		*f1 = _vala_f1;
#line 5991 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (promotion_type) {
#line 975 "../lib/chess-state.vala"
		*promotion_type = _vala_promotion_type;
#line 5997 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	return result;
#line 6001 "chess-state.c"
}


ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
	Color _tmp2_;
#line 27 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 27 "../lib/chess-state.vala"
	_tmp2_ = _tmp1_->color;
#line 27 "../lib/chess-state.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 6020 "chess-state.c"
		ChessPlayer* _tmp3_;
#line 27 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_BLACK];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 6026 "chess-state.c"
	} else {
		ChessPlayer* _tmp4_;
#line 27 "../lib/chess-state.vala"
		_tmp4_ = self->players[COLOR_WHITE];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp4_;
#line 6033 "chess-state.c"
	}
#line 27 "../lib/chess-state.vala"
	result = _tmp0_;
#line 27 "../lib/chess-state.vala"
	return result;
#line 6039 "chess-state.c"
}


static void
chess_state_class_init (ChessStateClass * klass)
{
#line 20 "../lib/chess-state.vala"
	chess_state_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/chess-state.vala"
	g_type_class_adjust_private_offset (klass, &ChessState_private_offset);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
#line 20 "../lib/chess-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6056 "chess-state.c"
}


static void
chess_state_instance_init (ChessState * self)
{
#line 20 "../lib/chess-state.vala"
	self->priv = chess_state_get_instance_private (self);
#line 22 "../lib/chess-state.vala"
	self->number = 0;
#line 31 "../lib/chess-state.vala"
	self->en_passant_index = -1;
#line 36 "../lib/chess-state.vala"
	self->last_move = NULL;
#line 6071 "chess-state.c"
}


static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
#line 20 "../lib/chess-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
#line 23 "../lib/chess-state.vala"
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
#line 24 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 35 "../lib/chess-state.vala"
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
#line 36 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
#line 6091 "chess-state.c"
}


GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__volatile = 0;
	if (g_once_init_enter (&chess_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
		GType chess_state_type_id;
		chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
		ChessState_private_offset = g_type_add_instance_private (chess_state_type_id, sizeof (ChessStatePrivate));
		g_once_init_leave (&chess_state_type_id__volatile, chess_state_type_id);
	}
	return chess_state_type_id__volatile;
}


static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
#line 20 "../lib/chess-state.vala"
	switch (property_id) {
#line 20 "../lib/chess-state.vala"
		case CHESS_STATE_OPPONENT_PROPERTY:
#line 20 "../lib/chess-state.vala"
		g_value_set_object (value, chess_state_get_opponent (self));
#line 20 "../lib/chess-state.vala"
		break;
#line 6126 "chess-state.c"
		default:
#line 20 "../lib/chess-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/chess-state.vala"
		break;
#line 6132 "chess-state.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



